#include <stdio.h>
#include <string.h>
#include <sys/stat.h>
#include <unistd.h>
#include <allegro.h>
#include "edop.h"
#include "ymw.h"
#include "FileIO.h"
#include "mem.h"

unsigned int get_world_ver( char *fn )
{
    PACKFILE *fh;
    unsigned short ver=0, rev=0;

    if( (fh = pack_fopen( fn, "rbp" )) == NULL )
      return 0;

    pack_fread( &ver, 2, fh );
    pack_fread( &rev, 2, fh );
    pack_fclose( fh );

    return ((ver<<16)|rev);
}

unsigned int load_world( char *fn, WORLD *world )
{
    PACKFILE *fh;
    int j=0, k=0, l=0, m=0, t=0;
//    int killbuf=0;
    unsigned short ver=0, rev=0;

    if( (fh = pack_fopen( fn, "rbp" )) == NULL )
      return 0;
    pack_fread( &ver, 2, fh );
    pack_fread( &rev, 2, fh );

    switch( ((ver<<16)|rev) ){
/*      case (1<<16)|1:
           pack_fread( &world->num_rooms, 4, fh );
           world->room = malloc( sizeof(ROOM) * world->num_rooms );
           for( j = 0; j < world->num_rooms; j++ ){
              pack_fread( &world->room[j].x, 4, fh );
              pack_fread( &world->room[j].y, 4, fh );
              pack_fread( &world->room[j].z, 4, fh );
              for( k = 0; k < 6; k++ ){
                 pack_fread( &world->room[j].door[k], 4, fh );
                 pack_fread( &world->room[j].si[k], 1, fh );
                 }

              world->room[j].title = malloc( NAMESIZE );
              for( k = 0; k < NAMESIZE/8; k++ ){
                 ((long long *)world->room[j].title)[k] = 0;
                 }

              world->room[j].desc = malloc( RDSIZE );
              for( k = 0; k < RDSIZE/8; k++ ){
                 ((long long *)world->room[j].desc)[k] = 0;
                 }

              pack_fread( &l, 4, fh );
              pack_fread( world->room[j].title, l, fh );
       
              pack_fread( &l, 4, fh );
              pack_fread( world->room[j].desc, l, fh );

              world->room[j].zone = 0;

              world->room[j].num_exd = 0;
              world->room[j].exd = malloc( 1 );

              world->room[j].num_cont = 0;
              world->room[j].content = malloc( 1 );
              }
           pack_fread( &world->num_doors, 4, fh );
           world->door = malloc( sizeof(DOOR) * world->num_doors );
           for( j = 0; j < world->num_doors; j++ ){
              for( k = 0; k < 2; k++ ){
                 pack_fread( &world->door[j].r[k], 4, fh );
                 pack_fread( &world->door[j].d[k], 4, fh );
                 world->door[j].desc[k] = malloc( RDSIZE );
                 for( l = 0; l < RDSIZE/8; l++ ){
                    ((long long *)world->door[j].desc[k])[l] = 0;
                    }

                 world->door[j].keywords[k] = malloc( NAMESIZE );
                 for( l = 0; l < NAMESIZE/8; l++ ){
                    ((long long *)world->door[j].keywords[k])[l] = 0;
                    }
                 }
              pack_fread( &world->door[j].flags, 4, fh );
              }
       
           pack_fclose( fh );

           world->zone = malloc( 1 );
           j = add_zone( world );
           break;

      case (1<<16)|2:
           pack_fread( &world->num_rooms, 4, fh );
           world->room = malloc( sizeof(ROOM) * world->num_rooms );
           for( j = 0; j < world->num_rooms; j++ ){
              pack_fread( &world->room[j].x, 4, fh );
              pack_fread( &world->room[j].y, 4, fh );
              pack_fread( &world->room[j].z, 4, fh );
              for( k = 0; k < 6; k++ ){
                 pack_fread( &world->room[j].door[k], 4, fh );
                 pack_fread( &world->room[j].si[k], 1, fh );
                 }
              world->room[j].title = malloc( NAMESIZE );
              for( k = 0; k < NAMESIZE/8; k++ ){
                 ((long long *)world->room[j].title)[k] = 0;
                 }

              world->room[j].desc = malloc( RDSIZE );
              for( k = 0; k < RDSIZE/8; k++ ){
                 ((long long *)world->room[j].desc)[k] = 0;
                 }

              pack_fread( &l, 4, fh );
              pack_fread( world->room[j].title, l, fh );
       
              pack_fread( &l, 4, fh );
              pack_fread( world->room[j].desc, l, fh );

              pack_fread( &world->room[j].vnum, 4, fh );

              world->room[j].num_exd = 0;
              world->room[j].exd = malloc( 1 );

              world->room[j].num_cont = 0;
              world->room[j].content = malloc( 1 );
              }
           pack_fread( &world->num_doors, 4, fh );
           world->door = malloc( sizeof(DOOR) * world->num_doors );
           for( j = 0; j < world->num_doors; j++ ){
              for( k = 0; k < 2; k++ ){
                 pack_fread( &world->door[j].r[k], 4, fh );
                 pack_fread( &world->door[j].d[k], 4, fh );
                 world->door[j].desc[k] = malloc( RDSIZE );
                 for( l = 0; l < RDSIZE/8; l++ ){
                    ((long long *)world->door[j].desc[k])[l] = 0;
                    }

                 world->door[j].keywords[k] = malloc( NAMESIZE );
                 for( l = 0; l < NAMESIZE/8; l++ ){
                    ((long long *)world->door[j].keywords[k])[l] = 0;
                    }
                 }
              pack_fread( &world->door[j].flags, 4, fh );
              }
       
           pack_fclose( fh );

           world->zone = malloc( 1 );
           j = add_zone( world );
           break;

      case (1<<16)|3:
           pack_fread( &world->num_rooms, 4, fh );
           world->room = malloc( sizeof(ROOM) * world->num_rooms );
           for( j = 0; j < world->num_rooms; j++ ){
              pack_fread( &world->room[j].x, 4, fh );
              pack_fread( &world->room[j].y, 4, fh );
              pack_fread( &world->room[j].z, 4, fh );
              for( k = 0; k < 6; k++ ){
                 pack_fread( &world->room[j].door[k], 4, fh );
                 pack_fread( &world->room[j].si[k], 1, fh );
                 }
              world->room[j].title = malloc( NAMESIZE );
              for( k = 0; k < NAMESIZE/8; k++ ){
                 ((long long *)world->room[j].title)[k] = 0;
                 }

              world->room[j].desc = malloc( RDSIZE );
              for( k = 0; k < RDSIZE/8; k++ ){
                 ((long long *)world->room[j].desc)[k] = 0;
                 }

              pack_fread( &l, 4, fh );
              pack_fread( world->room[j].title, l, fh );
       
              pack_fread( &l, 4, fh );
              pack_fread( world->room[j].desc, l, fh );

              pack_fread( &world->room[j].vnum, 4, fh );
              world->room[j].vnum = j;
              pack_fread( &world->room[j].zone, 4, fh );

              world->room[j].num_exd = 0;
              world->room[j].exd = malloc( 1 );

              world->room[j].num_cont = 0;
              world->room[j].content = malloc( 1 );
              }
           pack_fread( &world->num_doors, 4, fh );
           world->door = malloc( sizeof(DOOR) * world->num_doors );
           for( j = 0; j < world->num_doors; j++ ){
              for( k = 0; k < 2; k++ ){
                 pack_fread( &world->door[j].r[k], 4, fh );
                 pack_fread( &world->door[j].d[k], 4, fh );
                 world->door[j].desc[k] = malloc( RDSIZE );
                 for( l = 0; l < RDSIZE/8; l++ ){
                    ((long long *)world->door[j].desc[k])[l] = 0;
                    }

                 world->door[j].keywords[k] = malloc( NAMESIZE );
                 for( l = 0; l < NAMESIZE/8; l++ ){
                    ((long long *)world->door[j].keywords[k])[l] = 0;
                    }
                 }
              pack_fread( &world->door[j].flags, 4, fh );
              }
       
           pack_fclose( fh );

           world->zone = malloc( 1 );
           j = add_zone( world );
           break;

      case (1<<16)|4:
           pack_fread( &world->num_rooms, 4, fh );
           world->room = malloc( sizeof(ROOM) * world->num_rooms );
           for( j = 0; j < world->num_rooms; j++ ){
              pack_fread( &world->room[j].x, 4, fh );
              pack_fread( &world->room[j].y, 4, fh );
              pack_fread( &world->room[j].z, 4, fh );
              for( k = 0; k < 6; k++ ){
                 pack_fread( &world->room[j].door[k], 4, fh );
                 pack_fread( &world->room[j].si[k], 1, fh );
                 }
              world->room[j].title = malloc( NAMESIZE );
              for( k = 0; k < NAMESIZE/8; k++ ){
                 ((long long *)world->room[j].title)[k] = 0;
                 }

              world->room[j].desc = malloc( RDSIZE );
              for( k = 0; k < RDSIZE/8; k++ ){
                 ((long long *)world->room[j].desc)[k] = 0;
                 }

              pack_fread( &l, 4, fh );
              pack_fread( world->room[j].title, l, fh );
       
              pack_fread( &l, 4, fh );
              pack_fread( world->room[j].desc, l, fh );

              pack_fread( &world->room[j].vnum, 4, fh );
              pack_fread( &killbuf, 4, fh );
              world->room[j].zone = 0;
              pack_fread( &killbuf, 4, fh );
              pack_fread( &world->room[j].rbv, 8, fh );
              pack_fread( &world->room[j].stype, 4, fh );

              world->room[j].num_exd = 0;
              world->room[j].exd = malloc( 1 );

              world->room[j].num_cont = 0;
              world->room[j].content = malloc( 1 );
              }
           pack_fread( &world->num_doors, 4, fh );
           world->door = malloc( sizeof(DOOR) * world->num_doors );
           for( j = 0; j < world->num_doors; j++ ){
              for( k = 0; k < 2; k++ ){
                 pack_fread( &world->door[j].r[k], 4, fh );
                 pack_fread( &world->door[j].d[k], 4, fh );
                 world->door[j].desc[k] = malloc( RDSIZE );
                 for( l = 0; l < RDSIZE/8; l++ ){
                    ((long long *)world->door[j].desc[k])[l] = 0;
                    }

                 world->door[j].keywords[k] = malloc( NAMESIZE );
                 for( l = 0; l < NAMESIZE/8; l++ ){
                    ((long long *)world->door[j].keywords[k])[l] = 0;
                    }
                 }
              pack_fread( &world->door[j].flags, 4, fh );
              }
           pack_fclose( fh );

           world->zone = malloc( 1 );
           j = add_zone( world );
           break;

      case (1<<16)|5:
           pack_fread( &world->num_rooms, 4, fh );
           world->room = malloc( sizeof(ROOM) * world->num_rooms );
           for( j = 0; j < world->num_rooms; j++ ){
              pack_fread( &world->room[j].x, 4, fh );
              pack_fread( &world->room[j].y, 4, fh );
              pack_fread( &world->room[j].z, 4, fh );
              for( k = 0; k < 6; k++ ){
                 pack_fread( &world->room[j].door[k], 4, fh );
                 pack_fread( &world->room[j].si[k], 1, fh );
                 }

              world->room[j].title = malloc( NAMESIZE );
              for( k = 0; k < NAMESIZE/8; k++ ){
                 ((long long *)world->room[j].title)[k] = 0;
                 }

              world->room[j].desc = malloc( RDSIZE );
              for( k = 0; k < RDSIZE/8; k++ ){
                 ((long long *)world->room[j].desc)[k] = 0;
                 }

              pack_fread( &l, 4, fh );
              pack_fread( world->room[j].title, l, fh );
       
              pack_fread( &l, 4, fh );
              pack_fread( world->room[j].desc, l, fh );

              pack_fread( &world->room[j].vnum, 4, fh );
              pack_fread( &world->room[j].zone, 4, fh );
              pack_fread( &world->room[j].rbv, 8, fh );
              pack_fread( &world->room[j].stype, 4, fh );

              world->room[j].num_exd = 0;
              world->room[j].exd = malloc( 1 );

              world->room[j].num_cont = 0;
              world->room[j].content = malloc( 1 );
              }
           pack_fread( &world->num_doors, 4, fh );
           world->door = malloc( sizeof(DOOR) * world->num_doors );
           for( j = 0; j < world->num_doors; j++ ){
              for( k = 0; k < 2; k++ ){
                 pack_fread( &world->door[j].r[k], 4, fh );
                 pack_fread( &world->door[j].d[k], 4, fh );
                 world->door[j].desc[k] = malloc( RDSIZE );
                 for( l = 0; l < RDSIZE/8; l++ ){
                    ((long long *)world->door[j].desc[k])[l] = 0;
                    }

                 world->door[j].keywords[k] = malloc( NAMESIZE );
                 for( l = 0; l < NAMESIZE/8; l++ ){
                    ((long long *)world->door[j].keywords[k])[l] = 0;
                    }
                 }
              pack_fread( &world->door[j].flags, 4, fh );
              }
           pack_fclose( fh );

           world->zone = malloc( 1 );
           j = add_zone( world );
           break;

      case (1<<16)|6:
           pack_fread( &world->num_rooms, 4, fh );
           world->room = malloc( sizeof(ROOM) * world->num_rooms );
           for( j = 0; j < world->num_rooms; j++ ){
              pack_fread( &world->room[j].x, 4, fh );
              pack_fread( &world->room[j].y, 4, fh );
              pack_fread( &world->room[j].z, 4, fh );
              for( k = 0; k < 6; k++ ){
                 pack_fread( &world->room[j].door[k], 4, fh );
                 pack_fread( &world->room[j].si[k], 1, fh );
                 }

              world->room[j].title = malloc( NAMESIZE );
              for( k = 0; k < NAMESIZE/8; k++ ){
                 ((long long *)world->room[j].title)[k] = 0;
                 }

              world->room[j].desc = malloc( RDSIZE );
              for( k = 0; k < RDSIZE/8; k++ ){
                 ((long long *)world->room[j].desc)[k] = 0;
                 }

              pack_fread( &l, 4, fh );
              pack_fread( world->room[j].title, l, fh );
       
              pack_fread( &l, 4, fh );
              pack_fread( world->room[j].desc, l, fh );

              pack_fread( &world->room[j].vnum, 4, fh );
              pack_fread( &world->room[j].zone, 4, fh );
              pack_fread( &world->room[j].rbv, 8, fh );
              pack_fread( &world->room[j].stype, 4, fh );

              world->room[j].num_exd = 0;
              world->room[j].exd = malloc( 1 );

              world->room[j].num_cont = 0;
              world->room[j].content = malloc( 1 );
              }
           pack_fread( &world->num_doors, 4, fh );
           world->door = malloc( sizeof(DOOR) * world->num_doors );
           for( j = 0; j < world->num_doors; j++ ){
              for( k = 0; k < 2; k++ ){
                 pack_fread( &world->door[j].r[k], 4, fh );
                 pack_fread( &world->door[j].d[k], 4, fh );
                 world->door[j].desc[k] = malloc( RDSIZE );
                 for( l = 0; l < RDSIZE/8; l++ ){
                    ((long long *)world->door[j].desc[k])[l] = 0;
                    }

                 world->door[j].keywords[k] = malloc( NAMESIZE );
                 for( l = 0; l < NAMESIZE/8; l++ ){
                    ((long long *)world->door[j].keywords[k])[l] = 0;
                    }
                 }
              pack_fread( &world->door[j].flags, 4, fh );
              }
           pack_fread( &world->num_zones, 4, fh );
           world->zone = malloc( sizeof(ZONE) * world->num_zones );
           for( j = 0; j < world->num_zones; j++ ){
              world->zone[j].name = malloc( NAMESIZE );
              for( k = 0; k < NAMESIZE/8; k++ ){
                 ((long long *)world->zone[j].name)[k] = 0;
                 }

              world->zone[j].author = malloc( NAMESIZE );
              for( k = 0; k < NAMESIZE/8; k++ ){
                 ((long long *)world->zone[j].author)[k] = 0;
                 }

              pack_fread( &l, 4, fh );
              pack_fread( world->zone[j].name, l, fh );
        
              pack_fread( &l, 4, fh );
              pack_fread( world->zone[j].author, l, fh );
        
              pack_fread( &world->zone[j].tint, 4, fh );
              pack_fread( &world->zone[j].vnum, 4, fh );
              pack_fread( &world->zone[j].life_span, 4, fh );
              pack_fread( &world->zone[j].reset_mode, 4, fh );
              pack_fread( &l, 4, fh );
              world->zone[j].rbv = 0;
              world->zone[j].stype = 0;
              world->zone[j].num_objects = 0;
              world->zone[j].object = malloc( 1 );

              world->zone[j].num_mobiles = 0;
              world->zone[j].mobile = malloc( 1 );
              }
           pack_fclose( fh );
           break;

      case (1<<16)|7:
           pack_fread( &world->num_rooms, 4, fh );
           world->room = malloc( sizeof(ROOM) * world->num_rooms );
           for( j = 0; j < world->num_rooms; j++ ){
              pack_fread( &world->room[j].x, 4, fh );
              pack_fread( &world->room[j].y, 4, fh );
              pack_fread( &world->room[j].z, 4, fh );
              for( k = 0; k < 6; k++ ){
                 pack_fread( &world->room[j].door[k], 4, fh );
                 pack_fread( &world->room[j].si[k], 1, fh );
                 }

              world->room[j].title = malloc( NAMESIZE );
              for( k = 0; k < NAMESIZE/8; k++ ){
                 ((long long *)world->room[j].title)[k] = 0;
                 }

              world->room[j].desc = malloc( RDSIZE );
              for( k = 0; k < RDSIZE/8; k++ ){
                 ((long long *)world->room[j].desc)[k] = 0;
                 }

              pack_fread( &l, 4, fh );
              pack_fread( world->room[j].title, l, fh );
       
              pack_fread( &l, 4, fh );
              pack_fread( world->room[j].desc, l, fh );

              pack_fread( &world->room[j].vnum, 4, fh );
              pack_fread( &world->room[j].zone, 4, fh );
              pack_fread( &world->room[j].rbv, 8, fh );
              pack_fread( &world->room[j].stype, 4, fh );

              world->room[j].num_exd = 0;
              world->room[j].exd = malloc( 1 );

              world->room[j].num_cont = 0;
              world->room[j].content = malloc( 1 );
              }
           pack_fread( &world->num_doors, 4, fh );
           world->door = malloc( sizeof(DOOR) * world->num_doors );
           for( j = 0; j < world->num_doors; j++ ){
              for( k = 0; k < 2; k++ ){
                 pack_fread( &world->door[j].r[k], 4, fh );
                 pack_fread( &world->door[j].d[k], 4, fh );
                 world->door[j].desc[k] = malloc( RDSIZE );
                 for( l = 0; l < RDSIZE/8; l++ ){
                    ((long long *)world->door[j].desc[k])[l] = 0;
                    }
                 pack_fread( &l, 4, fh );
                 pack_fread( world->door[j].desc[k], l, fh );

                 world->door[j].keywords[k] = malloc( NAMESIZE );
                 for( l = 0; l < NAMESIZE/8; l++ ){
                    ((long long *)world->door[j].keywords[k])[l] = 0;
                    }
                 }
              pack_fread( &world->door[j].flags, 4, fh );
              }
           pack_fread( &world->num_zones, 4, fh );
           world->zone = malloc( sizeof(ZONE) * world->num_zones );
           for( j = 0; j < world->num_zones; j++ ){
              world->zone[j].name = malloc( NAMESIZE );
              for( k = 0; k < NAMESIZE/8; k++ ){
                 ((long long *)world->zone[j].name)[k] = 0;
                 }

              world->zone[j].author = malloc( NAMESIZE );
              for( k = 0; k < NAMESIZE/8; k++ ){
                 ((long long *)world->zone[j].author)[k] = 0;
                 }

              pack_fread( &l, 4, fh );
              pack_fread( world->zone[j].name, l, fh );
        
              pack_fread( &l, 4, fh );
              pack_fread( world->zone[j].author, l, fh );
        
              pack_fread( &world->zone[j].tint, 4, fh );
              pack_fread( &world->zone[j].vnum, 4, fh );
              pack_fread( &world->zone[j].life_span, 4, fh );
              pack_fread( &world->zone[j].reset_mode, 4, fh );
              pack_fread( &l, 4, fh );
              world->zone[j].rbv = 0;
              world->zone[j].stype = 0;
              world->zone[j].num_objects = 0;
              world->zone[j].object = malloc( 1 );

              world->zone[j].num_mobiles = 0;
              world->zone[j].mobile = malloc( 1 );
              }
           pack_fclose( fh );
           break;

      case (1<<16)|8:
           pack_fread( &world->num_rooms, 4, fh );
           world->room = malloc( sizeof(ROOM) * world->num_rooms );
           for( j = 0; j < world->num_rooms; j++ ){
              pack_fread( &world->room[j].x, 4, fh );
              pack_fread( &world->room[j].y, 4, fh );
              pack_fread( &world->room[j].z, 4, fh );
              for( k = 0; k < 6; k++ ){
                 pack_fread( &world->room[j].door[k], 4, fh );
                 pack_fread( &world->room[j].si[k], 1, fh );
                 }

              world->room[j].title = malloc( NAMESIZE );
              for( k = 0; k < NAMESIZE/8; k++ ){
                 ((long long *)world->room[j].title)[k] = 0;
                 }

              world->room[j].desc = malloc( RDSIZE );
              for( k = 0; k < RDSIZE/8; k++ ){
                 ((long long *)world->room[j].desc)[k] = 0;
                 }

              pack_fread( &l, 4, fh );
              pack_fread( world->room[j].title, l, fh );
       
              pack_fread( &l, 4, fh );
              pack_fread( world->room[j].desc, l, fh );

              pack_fread( &world->room[j].vnum, 4, fh );
              pack_fread( &world->room[j].zone, 4, fh );
              pack_fread( &world->room[j].rbv, 8, fh );
              pack_fread( &world->room[j].stype, 4, fh );

              world->room[j].num_exd = 0;
              world->room[j].exd = malloc( 1 );

              world->room[j].num_cont = 0;
              world->room[j].content = malloc( 1 );
              }
           pack_fread( &world->num_doors, 4, fh );
           world->door = malloc( sizeof(DOOR) * world->num_doors );
           for( j = 0; j < world->num_doors; j++ ){
              for( k = 0; k < 2; k++ ){
                 pack_fread( &world->door[j].r[k], 4, fh );
                 pack_fread( &world->door[j].d[k], 4, fh );
                 world->door[j].desc[k] = malloc( RDSIZE );
                 for( l = 0; l < RDSIZE/8; l++ ){
                    ((long long *)world->door[j].desc[k])[l] = 0;
                    }
                 pack_fread( &l, 4, fh );
                 pack_fread( world->door[j].desc[k], l, fh );

                 world->door[j].keywords[k] = malloc( NAMESIZE );
                 for( l = 0; l < NAMESIZE/8; l++ ){
                    ((long long *)world->door[j].keywords[k])[l] = 0;
                    }
                 }
              pack_fread( &world->door[j].flags, 4, fh );
              }
           pack_fread( &world->num_zones, 4, fh );
           world->zone = malloc( sizeof(ZONE) * world->num_zones );
           for( j = 0; j < world->num_zones; j++ ){
              world->zone[j].name = malloc( NAMESIZE );
              for( k = 0; k < NAMESIZE/8; k++ ){
                 ((long long *)world->zone[j].name)[k] = 0;
                 }

              world->zone[j].author = malloc( NAMESIZE );
              for( k = 0; k < NAMESIZE/8; k++ ){
                 ((long long *)world->zone[j].author)[k] = 0;
                 }

              pack_fread( &l, 4, fh );
              pack_fread( world->zone[j].name, l, fh );
        
              pack_fread( &l, 4, fh );
              pack_fread( world->zone[j].author, l, fh );
        
              pack_fread( &world->zone[j].tint, 4, fh );
              pack_fread( &world->zone[j].vnum, 4, fh );
              pack_fread( &world->zone[j].life_span, 4, fh );
              pack_fread( &world->zone[j].reset_mode, 4, fh );
              pack_fread( &l, 4, fh );
              world->zone[j].rbv = 0;
              world->zone[j].stype = 0;
              world->zone[j].num_objects = 0;
              world->zone[j].object = malloc( 1 );

              world->zone[j].num_mobiles = 0;
              world->zone[j].mobile = malloc( 1 );
              }
           pack_fread( &world->num_tags, 4, fh );
           world->tag = malloc( sizeof(TAG) * world->num_tags );
           for( j = 0; j < world->num_tags; j++ ){
              world->tag[j].str = malloc( NAMESIZE );
              for( k = 0; k < NAMESIZE/8; k++ ){
                 ((long long *)world->tag[j].str)[k] = 0;
                 }

              pack_fread( &l, 4, fh );
              pack_fread( world->tag[j].str, l, fh );

              pack_fread( &world->tag[j].x, 4, fh );
              pack_fread( &world->tag[j].y, 4, fh );
              pack_fread( &world->tag[j].z, 4, fh );
              pack_fread( &world->tag[j].zone, 4, fh );
              }
           pack_fclose( fh );
           break;

      case (1<<16)|9:
           pack_fread( &world->num_rooms, 4, fh );
           world->room = malloc( sizeof(ROOM) * world->num_rooms );
           for( j = 0; j < world->num_rooms; j++ ){
              pack_fread( &world->room[j].x, 4, fh );
              pack_fread( &world->room[j].y, 4, fh );
              pack_fread( &world->room[j].z, 4, fh );
              for( k = 0; k < 6; k++ ){
                 pack_fread( &world->room[j].door[k], 4, fh );
                 pack_fread( &world->room[j].si[k], 1, fh );
                 }

              world->room[j].title = malloc( NAMESIZE );
              for( k = 0; k < NAMESIZE/8; k++ ){
                 ((long long *)world->room[j].title)[k] = 0;
                 }

              world->room[j].desc = malloc( RDSIZE );
              for( k = 0; k < RDSIZE/8; k++ ){
                 ((long long *)world->room[j].desc)[k] = 0;
                 }

              pack_fread( &l, 4, fh );
              pack_fread( world->room[j].title, l, fh );
       
              pack_fread( &l, 4, fh );
              pack_fread( world->room[j].desc, l, fh );

              pack_fread( &world->room[j].vnum, 4, fh );
              pack_fread( &world->room[j].zone, 4, fh );
              pack_fread( &world->room[j].rbv, 8, fh );
              pack_fread( &world->room[j].stype, 4, fh );

              world->room[j].num_exd = 0;
              world->room[j].exd = malloc( 1 );

              world->room[j].num_cont = 0;
              world->room[j].content = malloc( 1 );
              }
           pack_fread( &world->num_doors, 4, fh );
           world->door = malloc( sizeof(DOOR) * world->num_doors );
           for( j = 0; j < world->num_doors; j++ ){
              for( k = 0; k < 2; k++ ){
                 pack_fread( &world->door[j].r[k], 4, fh );
                 pack_fread( &world->door[j].d[k], 4, fh );
                 world->door[j].desc[k] = malloc( RDSIZE );
                 for( l = 0; l < RDSIZE/8; l++ ){
                    ((long long *)world->door[j].desc[k])[l] = 0;
                    }
                 pack_fread( &l, 4, fh );
                 pack_fread( world->door[j].desc[k], l, fh );

                 world->door[j].keywords[k] = malloc( NAMESIZE );
                 for( l = 0; l < NAMESIZE/8; l++ ){
                    ((long long *)world->door[j].keywords[k])[l] = 0;
                    }
                 }
              pack_fread( &world->door[j].flags, 4, fh );
              }
           pack_fread( &world->num_zones, 4, fh );
           world->zone = malloc( sizeof(ZONE) * world->num_zones );
           for( j = 0; j < world->num_zones; j++ ){
              world->zone[j].name = malloc( NAMESIZE );
              for( k = 0; k < NAMESIZE/8; k++ ){
                 ((long long *)world->zone[j].name)[k] = 0;
                 }

              world->zone[j].author = malloc( NAMESIZE );
              for( k = 0; k < NAMESIZE/8; k++ ){
                 ((long long *)world->zone[j].author)[k] = 0;
                 }

              pack_fread( &l, 4, fh );
              pack_fread( world->zone[j].name, l, fh );
        
              pack_fread( &l, 4, fh );
              pack_fread( world->zone[j].author, l, fh );
        
              pack_fread( &world->zone[j].tint, 4, fh );
              pack_fread( &world->zone[j].vnum, 4, fh );
              pack_fread( &world->zone[j].life_span, 4, fh );
              pack_fread( &world->zone[j].reset_mode, 4, fh );
              pack_fread( &l, 4, fh );
              pack_fread( &world->zone[j].stype, 4, fh );
              pack_fread( &world->zone[j].rbv, 8, fh );

              world->zone[j].num_objects = 0;
              world->zone[j].object = malloc( 1 );

              world->zone[j].num_mobiles = 0;
              world->zone[j].mobile = malloc( 1 );
              }
           pack_fread( &world->num_tags, 4, fh );
           world->tag = malloc( sizeof(TAG) * world->num_tags );
           for( j = 0; j < world->num_tags; j++ ){
              world->tag[j].str = malloc( NAMESIZE );
              for( k = 0; k < NAMESIZE/8; k++ ){
                 ((long long *)world->tag[j].str)[k] = 0;
                 }

              pack_fread( &l, 4, fh );
              pack_fread( world->tag[j].str, l, fh );

              pack_fread( &world->tag[j].x, 4, fh );
              pack_fread( &world->tag[j].y, 4, fh );
              pack_fread( &world->tag[j].z, 4, fh );
              pack_fread( &world->tag[j].zone, 4, fh );
              }
           pack_fclose( fh );
           break;

      case (1<<16)|10:
           pack_fread( &world->num_rooms, 4, fh );
           world->room = malloc( sizeof(ROOM) * world->num_rooms );
           for( j = 0; j < world->num_rooms; j++ ){
              pack_fread( &world->room[j].x, 4, fh );
              pack_fread( &world->room[j].y, 4, fh );
              pack_fread( &world->room[j].z, 4, fh );
              for( k = 0; k < 6; k++ ){
                 pack_fread( &world->room[j].door[k], 4, fh );
                 pack_fread( &world->room[j].si[k], 1, fh );
                 }

              world->room[j].title = malloc( NAMESIZE );
              for( k = 0; k < NAMESIZE/8; k++ ){
                 ((long long *)world->room[j].title)[k] = 0;
                 }

              world->room[j].desc = malloc( RDSIZE );
              for( k = 0; k < RDSIZE/8; k++ ){
                 ((long long *)world->room[j].desc)[k] = 0;
                 }

              pack_fread( &l, 4, fh );
              pack_fread( world->room[j].title, l, fh );
       
              pack_fread( &l, 4, fh );
              pack_fread( world->room[j].desc, l, fh );

              pack_fread( &world->room[j].vnum, 4, fh );
              pack_fread( &world->room[j].zone, 4, fh );
              pack_fread( &world->room[j].rbv, 8, fh );
              pack_fread( &world->room[j].stype, 4, fh );

              pack_fread( &world->room[j].num_exd, 4, fh );
              world->room[j].exd = malloc( MAX( 1, sizeof(EXD)*(world->room[j].num_exd) ) );
              for( k = 0; k < world->room[j].num_exd; k++ ){
                 world->room[j].exd[k].keywords = malloc( NAMESIZE );
                 for( l = 0; l < NAMESIZE/8; l++ ){
                    ((long long *)world->room[j].exd[k].keywords)[l] = 0;
                    }
                 pack_fread( &l, 4, fh );
                 pack_fread( world->room[j].exd[k].keywords, l, fh );
       
                 world->room[j].exd[k].desc = malloc( NAMESIZE );
                 for( l = 0; l < NAMESIZE/8; l++ ){
                    ((long long *)world->room[j].exd[k].desc)[l] = 0;
                    }
                 pack_fread( &l, 4, fh );
                 pack_fread( world->room[j].exd[k].desc, l, fh );
                 }
              world->room[j].num_cont = 0;
              world->room[j].content = malloc( 1 );
              }
           pack_fread( &world->num_doors, 4, fh );
           world->door = malloc( sizeof(DOOR) * world->num_doors );
           for( j = 0; j < world->num_doors; j++ ){
              for( k = 0; k < 2; k++ ){
                 pack_fread( &world->door[j].r[k], 4, fh );
                 pack_fread( &world->door[j].d[k], 4, fh );
                 world->door[j].desc[k] = malloc( RDSIZE );
                 for( l = 0; l < RDSIZE/8; l++ ){
                    ((long long *)world->door[j].desc[k])[l] = 0;
                    }
                 pack_fread( &l, 4, fh );
                 pack_fread( world->door[j].desc[k], l, fh );

                 world->door[j].keywords[k] = malloc( NAMESIZE );
                 for( l = 0; l < NAMESIZE/8; l++ ){
                    ((long long *)world->door[j].keywords[k])[l] = 0;
                    }
                 pack_fread( &l, 4, fh );
                 pack_fread( world->door[j].keywords[k], l, fh );
                 }
              pack_fread( &world->door[j].flags, 4, fh );
              }
           pack_fread( &world->num_zones, 4, fh );
           world->zone = malloc( sizeof(ZONE) * world->num_zones );
           for( j = 0; j < world->num_zones; j++ ){
              world->zone[j].name = malloc( NAMESIZE );
              for( k = 0; k < NAMESIZE/8; k++ ){
                 ((long long *)world->zone[j].name)[k] = 0;
                 }

              world->zone[j].author = malloc( NAMESIZE );
              for( k = 0; k < NAMESIZE/8; k++ ){
                 ((long long *)world->zone[j].author)[k] = 0;
                 }

              pack_fread( &l, 4, fh );
              pack_fread( world->zone[j].name, l, fh );
        
              pack_fread( &l, 4, fh );
              pack_fread( world->zone[j].author, l, fh );
        
              pack_fread( &world->zone[j].tint, 4, fh );
              pack_fread( &world->zone[j].vnum, 4, fh );
              pack_fread( &world->zone[j].life_span, 4, fh );
              pack_fread( &world->zone[j].reset_mode, 4, fh );
              pack_fread( &l, 4, fh );
              pack_fread( &world->zone[j].stype, 4, fh );
              pack_fread( &world->zone[j].rbv, 8, fh );

              world->zone[j].num_objects = 0;
              world->zone[j].object = malloc( 1 );

              world->zone[j].num_mobiles = 0;
              world->zone[j].mobile = malloc( 1 );
              }
           pack_fread( &world->num_tags, 4, fh );
           world->tag = malloc( sizeof(TAG) * world->num_tags );
           for( j = 0; j < world->num_tags; j++ ){
              world->tag[j].str = malloc( NAMESIZE );
              for( k = 0; k < NAMESIZE/8; k++ ){
                 ((long long *)world->tag[j].str)[k] = 0;
                 }

              pack_fread( &l, 4, fh );
              pack_fread( world->tag[j].str, l, fh );

              pack_fread( &world->tag[j].x, 4, fh );
              pack_fread( &world->tag[j].y, 4, fh );
              pack_fread( &world->tag[j].z, 4, fh );
              pack_fread( &world->tag[j].zone, 4, fh );
              }
           pack_fclose( fh );
           break;

      case (1<<16)|11:
           pack_fread( &world->num_rooms, 4, fh );
           world->room = malloc( sizeof(ROOM) * world->num_rooms );
           for( j = 0; j < world->num_rooms; j++ ){
              pack_fread( &world->room[j].x, 4, fh );
              pack_fread( &world->room[j].y, 4, fh );
              pack_fread( &world->room[j].z, 4, fh );
              for( k = 0; k < 6; k++ ){
                 pack_fread( &world->room[j].door[k], 4, fh );
                 pack_fread( &world->room[j].si[k], 1, fh );
                 }

              world->room[j].title = malloc( NAMESIZE );
              for( k = 0; k < NAMESIZE/8; k++ ){
                 ((long long *)world->room[j].title)[k] = 0;
                 }

              world->room[j].desc = malloc( RDSIZE );
              for( k = 0; k < RDSIZE/8; k++ ){
                 ((long long *)world->room[j].desc)[k] = 0;
                 }

              pack_fread( &l, 4, fh );
              pack_fread( world->room[j].title, l, fh );
       
              pack_fread( &l, 4, fh );
              pack_fread( world->room[j].desc, l, fh );

              pack_fread( &world->room[j].vnum, 4, fh );
              pack_fread( &world->room[j].zone, 4, fh );
              pack_fread( &world->room[j].rbv, 8, fh );
              pack_fread( &world->room[j].stype, 4, fh );

              pack_fread( &world->room[j].num_exd, 4, fh );
              world->room[j].exd = malloc( MAX( 1, sizeof(EXD)*(world->room[j].num_exd) ) );
              for( k = 0; k < world->room[j].num_exd; k++ ){
                 world->room[j].exd[k].keywords = malloc( NAMESIZE );
                 for( l = 0; l < NAMESIZE/8; l++ ){
                    ((long long *)world->room[j].exd[k].keywords)[l] = 0;
                    }
                 pack_fread( &l, 4, fh );
                 pack_fread( world->room[j].exd[k].keywords, l, fh );
       
                 world->room[j].exd[k].desc = malloc( NAMESIZE );
                 for( l = 0; l < NAMESIZE/8; l++ ){
                    ((long long *)world->room[j].exd[k].desc)[l] = 0;
                    }
                 pack_fread( &l, 4, fh );
                 pack_fread( world->room[j].exd[k].desc, l, fh );
                 }
              world->room[j].num_cont = 0;
              world->room[j].content = malloc( 1 );
              }
           pack_fread( &world->num_doors, 4, fh );
           world->door = malloc( sizeof(DOOR) * world->num_doors );
           for( j = 0; j < world->num_doors; j++ ){
              for( k = 0; k < 2; k++ ){
                 pack_fread( &world->door[j].r[k], 4, fh );
                 pack_fread( &world->door[j].d[k], 4, fh );
                 world->door[j].desc[k] = malloc( RDSIZE );
                 for( l = 0; l < RDSIZE/8; l++ ){
                    ((long long *)world->door[j].desc[k])[l] = 0;
                    }
                 pack_fread( &l, 4, fh );
                 pack_fread( world->door[j].desc[k], l, fh );

                 world->door[j].keywords[k] = malloc( NAMESIZE );
                 for( l = 0; l < NAMESIZE/8; l++ ){
                    ((long long *)world->door[j].keywords[k])[l] = 0;
                    }
                 pack_fread( &l, 4, fh );
                 pack_fread( world->door[j].keywords[k], l, fh );
                 }
              pack_fread( &world->door[j].flags, 4, fh );
              }
           pack_fread( &world->num_zones, 4, fh );
           world->zone = malloc( sizeof(ZONE) * world->num_zones );
           for( j = 0; j < world->num_zones; j++ ){
              world->zone[j].name = malloc( NAMESIZE );
              for( k = 0; k < NAMESIZE/8; k++ ){
                 ((long long *)world->zone[j].name)[k] = 0;
                 }

              world->zone[j].author = malloc( NAMESIZE );
              for( k = 0; k < NAMESIZE/8; k++ ){
                 ((long long *)world->zone[j].author)[k] = 0;
                 }

              pack_fread( &l, 4, fh );
              pack_fread( world->zone[j].name, l, fh );
        
              pack_fread( &l, 4, fh );
              pack_fread( world->zone[j].author, l, fh );
        
              pack_fread( &world->zone[j].tint, 4, fh );
              pack_fread( &world->zone[j].vnum, 4, fh );
              pack_fread( &world->zone[j].life_span, 4, fh );
              pack_fread( &world->zone[j].reset_mode, 4, fh );
              pack_fread( &world->zone[j].stype, 4, fh );
              pack_fread( &world->zone[j].rbv, 8, fh );

              pack_fread( &world->zone[j].num_objects, 4, fh );
              world->zone[j].object = malloc( sizeof(OBJECT) * world->zone[j].num_objects );
              for( k = 0; k < world->zone[j].num_objects; k++ ){
                 pack_fread( &world->zone[j].object[k].vnum, 4, fh );

                 world->zone[j].object[k].keywords = malloc( NAMESIZE );
                 for( l = 0; l < NAMESIZE/8; l++ ){
                    ((long long *)world->zone[j].object[k].keywords)[l] = 0;
                    }

                 world->zone[j].object[k].short_desc = malloc( NAMESIZE );
                 for( l = 0; l < NAMESIZE/8; l++ ){
                    ((long long *)world->zone[j].object[k].short_desc)[l] = 0;
                    }

                 world->zone[j].object[k].long_desc = malloc( NAMESIZE );
                 for( l = 0; l < NAMESIZE/8; l++ ){
                    ((long long *)world->zone[j].object[k].long_desc)[l] = 0;
                    }

                 world->zone[j].object[k].action_desc = malloc( NAMESIZE );
                 for( l = 0; l < NAMESIZE/8; l++ ){
                    ((long long *)world->zone[j].object[k].action_desc)[l] = 0;
                    }

                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].keywords, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].short_desc, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].long_desc, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].action_desc, l, fh );
       
                 pack_fread( &world->zone[j].object[k].type, 4, fh );
                 pack_fread( &world->zone[j].object[k].ebv, 8, fh );
                 pack_fread( &world->zone[j].object[k].wbv, 8, fh );
                 pack_fread( world->zone[j].object[k].value, 16, fh );
                 pack_fread( &world->zone[j].object[k].weight, 4, fh );
                 pack_fread( &world->zone[j].object[k].cost, 4, fh );
                 pack_fread( &world->zone[j].object[k].rpd, 4, fh );
                 pack_fread( &world->zone[j].object[k].num_exd, 4, fh );
                 world->zone[j].object[k].exd = malloc( sizeof(EXD) * world->zone[j].object[k].num_exd );
                 for( m = 0; m < world->zone[j].object[k].num_exd; m++ ){
                    world->zone[j].object[k].exd[m].keywords = malloc( NAMESIZE );
                    for( l = 0; l < NAMESIZE/8; l++ ){
                       ((long long *)world->zone[j].object[k].exd[m].keywords)[l] = 0;
                       }

                    world->zone[j].object[k].exd[m].desc = malloc( RDSIZE );
                    for( l = 0; l < RDSIZE/8; l++ ){
                       ((long long *)world->zone[j].object[k].exd[m].desc)[l] = 0;
                       }

                    pack_fread( &l, 4, fh );
                    pack_fread( world->zone[j].object[k].exd[m].keywords, l, fh );
       
                    pack_fread( &l, 4, fh );
                    pack_fread( world->zone[j].object[k].exd[m].desc, l, fh );
                    }
                 pack_fread( &world->zone[j].object[k].num_affect, 4, fh );
                 world->zone[j].object[k].affect = malloc( sizeof(OAFFECT) * world->zone[j].object[k].num_affect );
                 for( m = 0; m < world->zone[j].object[k].num_affect; m++ ){
                    pack_fread( &world->zone[j].object[k].affect[m].location, 4, fh );
                    pack_fread( &world->zone[j].object[k].affect[m].value, 4, fh );
                    }
                 }

                 world->zone[j].num_mobiles = 0;
                 world->zone[j].mobile = malloc( 1 );
              }
           pack_fread( &world->num_tags, 4, fh );
           world->tag = malloc( sizeof(TAG) * world->num_tags );
           for( j = 0; j < world->num_tags; j++ ){
              world->tag[j].str = malloc( NAMESIZE );
              for( k = 0; k < NAMESIZE/8; k++ ){
                 ((long long *)world->tag[j].str)[k] = 0;
                 }

              pack_fread( &l, 4, fh );
              pack_fread( world->tag[j].str, l, fh );

              pack_fread( &world->tag[j].x, 4, fh );
              pack_fread( &world->tag[j].y, 4, fh );
              pack_fread( &world->tag[j].z, 4, fh );
              pack_fread( &world->tag[j].zone, 4, fh );
              }
           pack_fclose( fh );
           break;

      case (1<<16)|12:
           pack_fread( &world->num_rooms, 4, fh );
           world->room = malloc( sizeof(ROOM) * world->num_rooms );
           for( j = 0; j < world->num_rooms; j++ ){
              pack_fread( &world->room[j].x, 4, fh );
              pack_fread( &world->room[j].y, 4, fh );
              pack_fread( &world->room[j].z, 4, fh );
              for( k = 0; k < 6; k++ ){
                 pack_fread( &world->room[j].door[k], 4, fh );
                 pack_fread( &world->room[j].si[k], 1, fh );
                 }

              world->room[j].title = malloc( NAMESIZE );
              for( k = 0; k < NAMESIZE/8; k++ ){
                 ((long long *)world->room[j].title)[k] = 0;
                 }

              world->room[j].desc = malloc( RDSIZE );
              for( k = 0; k < RDSIZE/8; k++ ){
                 ((long long *)world->room[j].desc)[k] = 0;
                 }

              pack_fread( &l, 4, fh );
              pack_fread( world->room[j].title, l, fh );
       
              pack_fread( &l, 4, fh );
              pack_fread( world->room[j].desc, l, fh );

              pack_fread( &world->room[j].vnum, 4, fh );
              pack_fread( &world->room[j].zone, 4, fh );
              pack_fread( &world->room[j].rbv, 8, fh );
              pack_fread( &world->room[j].stype, 4, fh );

              pack_fread( &world->room[j].num_exd, 4, fh );
              world->room[j].exd = malloc( MAX( 1, sizeof(EXD)*(world->room[j].num_exd) ) );
              for( k = 0; k < world->room[j].num_exd; k++ ){
                 world->room[j].exd[k].keywords = malloc( NAMESIZE );
                 for( l = 0; l < NAMESIZE/8; l++ ){
                    ((long long *)world->room[j].exd[k].keywords)[l] = 0;
                    }
                 pack_fread( &l, 4, fh );
                 pack_fread( world->room[j].exd[k].keywords, l, fh );
       
                 world->room[j].exd[k].desc = malloc( NAMESIZE );
                 for( l = 0; l < NAMESIZE/8; l++ ){
                    ((long long *)world->room[j].exd[k].desc)[l] = 0;
                    }
                 pack_fread( &l, 4, fh );
                 pack_fread( world->room[j].exd[k].desc, l, fh );
                 }
              world->room[j].num_cont = 0;
              world->room[j].content = malloc( 1 );
              }
           pack_fread( &world->num_doors, 4, fh );
           world->door = malloc( sizeof(DOOR) * world->num_doors );
           for( j = 0; j < world->num_doors; j++ ){
              for( k = 0; k < 2; k++ ){
                 pack_fread( &world->door[j].r[k], 4, fh );
                 pack_fread( &world->door[j].d[k], 4, fh );
                 world->door[j].desc[k] = malloc( RDSIZE );
                 for( l = 0; l < RDSIZE/8; l++ ){
                    ((long long *)world->door[j].desc[k])[l] = 0;
                    }
                 pack_fread( &l, 4, fh );
                 pack_fread( world->door[j].desc[k], l, fh );

                 world->door[j].keywords[k] = malloc( NAMESIZE );
                 for( l = 0; l < NAMESIZE/8; l++ ){
                    ((long long *)world->door[j].keywords[k])[l] = 0;
                    }
                 pack_fread( &l, 4, fh );
                 pack_fread( world->door[j].keywords[k], l, fh );
                 }
              pack_fread( &world->door[j].flags, 4, fh );
              }
           pack_fread( &world->num_zones, 4, fh );
           world->zone = malloc( sizeof(ZONE) * world->num_zones );
           for( j = 0; j < world->num_zones; j++ ){
              world->zone[j].name = malloc( NAMESIZE );
              for( k = 0; k < NAMESIZE/8; k++ ){
                 ((long long *)world->zone[j].name)[k] = 0;
                 }

              world->zone[j].author = malloc( NAMESIZE );
              for( k = 0; k < NAMESIZE/8; k++ ){
                 ((long long *)world->zone[j].author)[k] = 0;
                 }

              pack_fread( &l, 4, fh );
              pack_fread( world->zone[j].name, l, fh );
        
              pack_fread( &l, 4, fh );
              pack_fread( world->zone[j].author, l, fh );
        
              pack_fread( &world->zone[j].tint, 4, fh );
              pack_fread( &world->zone[j].vnum, 4, fh );
              pack_fread( &world->zone[j].life_span, 4, fh );
              pack_fread( &world->zone[j].reset_mode, 4, fh );
              pack_fread( &world->zone[j].stype, 4, fh );
              pack_fread( &world->zone[j].rbv, 8, fh );

              pack_fread( &world->zone[j].num_objects, 4, fh );
              world->zone[j].object = malloc( sizeof(OBJECT) * world->zone[j].num_objects );
              for( k = 0; k < world->zone[j].num_objects; k++ ){
                 pack_fread( &world->zone[j].object[k].vnum, 4, fh );

                 world->zone[j].object[k].keywords = malloc( NAMESIZE );
                 for( l = 0; l < NAMESIZE/8; l++ ){
                    ((long long *)world->zone[j].object[k].keywords)[l] = 0;
                    }

                 world->zone[j].object[k].short_desc = malloc( NAMESIZE );
                 for( l = 0; l < NAMESIZE/8; l++ ){
                    ((long long *)world->zone[j].object[k].short_desc)[l] = 0;
                    }

                 world->zone[j].object[k].long_desc = malloc( NAMESIZE );
                 for( l = 0; l < NAMESIZE/8; l++ ){
                    ((long long *)world->zone[j].object[k].long_desc)[l] = 0;
                    }

                 world->zone[j].object[k].action_desc = malloc( NAMESIZE );
                 for( l = 0; l < NAMESIZE/8; l++ ){
                    ((long long *)world->zone[j].object[k].action_desc)[l] = 0;
                    }

                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].keywords, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].short_desc, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].long_desc, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].action_desc, l, fh );
       
                 pack_fread( &world->zone[j].object[k].type, 4, fh );
                 pack_fread( &world->zone[j].object[k].ebv, 8, fh );
                 pack_fread( &world->zone[j].object[k].wbv, 8, fh );
                 pack_fread( world->zone[j].object[k].value, 16, fh );
                 pack_fread( &world->zone[j].object[k].weight, 4, fh );
                 pack_fread( &world->zone[j].object[k].cost, 4, fh );
                 pack_fread( &world->zone[j].object[k].rpd, 4, fh );
                 pack_fread( &world->zone[j].object[k].num_exd, 4, fh );
                 world->zone[j].object[k].exd = malloc( sizeof(EXD) * world->zone[j].object[k].num_exd );
                 for( m = 0; m < world->zone[j].object[k].num_exd; m++ ){
                    world->zone[j].object[k].exd[m].keywords = malloc( NAMESIZE );
                    for( l = 0; l < NAMESIZE/8; l++ ){
                       ((long long *)world->zone[j].object[k].exd[m].keywords)[l] = 0;
                       }

                    world->zone[j].object[k].exd[m].desc = malloc( RDSIZE );
                    for( l = 0; l < RDSIZE/8; l++ ){
                       ((long long *)world->zone[j].object[k].exd[m].desc)[l] = 0;
                       }

                    pack_fread( &l, 4, fh );
                    pack_fread( world->zone[j].object[k].exd[m].keywords, l, fh );
       
                    pack_fread( &l, 4, fh );
                    pack_fread( world->zone[j].object[k].exd[m].desc, l, fh );
                    }
                 pack_fread( &world->zone[j].object[k].num_affect, 4, fh );
                 world->zone[j].object[k].affect = malloc( sizeof(OAFFECT) * world->zone[j].object[k].num_affect );
                 for( m = 0; m < world->zone[j].object[k].num_affect; m++ ){
                    pack_fread( &world->zone[j].object[k].affect[m].location, 4, fh );
                    pack_fread( &world->zone[j].object[k].affect[m].value, 4, fh );
                    }
                 }

              pack_fread( &world->zone[j].num_mobiles, 4, fh );
              world->zone[j].mobile = malloc( sizeof(MOBILE) * world->zone[j].num_mobiles );
              for( k = 0; k < world->zone[j].num_mobiles; k++ ){
                 world->zone[j].mobile[k].keywords = malloc( NAMESIZE );
                 for( l = 0; l < NAMESIZE/8; l++ ){
                    ((long long *)world->zone[j].mobile[k].keywords)[l] = 0;
                    }

                 world->zone[j].mobile[k].short_desc = malloc( NAMESIZE );
                 for( l = 0; l < NAMESIZE/8; l++ ){
                    ((long long *)world->zone[j].mobile[k].short_desc)[l] = 0;
                    }

                 world->zone[j].mobile[k].long_desc = malloc( NAMESIZE );
                 for( l = 0; l < NAMESIZE/8; l++ ){
                    ((long long *)world->zone[j].mobile[k].long_desc)[l] = 0;
                    }

                 world->zone[j].mobile[k].detail_desc = malloc( RDSIZE );
                 for( l = 0; l < RDSIZE/8; l++ ){
                    ((long long *)world->zone[j].mobile[k].detail_desc)[l] = 0;
                    }

                 pack_fread( &world->zone[j].mobile[k].vnum, 4, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].mobile[k].keywords, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].mobile[k].short_desc, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].mobile[k].long_desc, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].mobile[k].detail_desc, l, fh );
       
                 pack_fread( &world->zone[j].mobile[k].actbv, 8, fh );
                 pack_fread( &world->zone[j].mobile[k].affbv, 8, fh );
                 pack_fread( &world->zone[j].mobile[k].alignment, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].typeflag, 1, fh );
                 pack_fread( &world->zone[j].mobile[k].level, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].thac0, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].ac, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].mhpx, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].mhpy, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].mhpz, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].bhdx, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].bhdy, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].bhdz, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].gold, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].exp, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].loadpos, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].defpos, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].sex, 1, fh );
                 pack_fread( &world->zone[j].mobile[k].num_especs, 4, fh );
                 world->zone[j].mobile[k].espec = malloc( sizeof(ESPEC)*world->zone[j].mobile[k].num_especs );
                 pack_fread( world->zone[j].mobile[k].espec, sizeof(ESPEC)*world->zone[j].mobile[k].num_especs, fh );
                 }
              }
           pack_fread( &world->num_tags, 4, fh );
           world->tag = malloc( sizeof(TAG) * world->num_tags );
           for( j = 0; j < world->num_tags; j++ ){
              world->tag[j].str = malloc( NAMESIZE );
              for( k = 0; k < NAMESIZE/8; k++ ){
                 ((long long *)world->tag[j].str)[k] = 0;
                 }

              pack_fread( &l, 4, fh );
              pack_fread( world->tag[j].str, l, fh );

              pack_fread( &world->tag[j].x, 4, fh );
              pack_fread( &world->tag[j].y, 4, fh );
              pack_fread( &world->tag[j].z, 4, fh );
              pack_fread( &world->tag[j].zone, 4, fh );
              }
           pack_fclose( fh );
           break;
*/

      case (1<<16)|13:
           pack_fread( &world->num_zones, 4, fh );
           pack_fread( &world->last_zone_vnum, 4, fh );
           world->zone = malloc( sizeof(ZONE) * world->num_zones );
           for( j = 0; j < world->num_zones; j++ ){
              world->zone[j].name = malloc( NAMESIZE );
              world->zone[j].author = malloc( NAMESIZE );

              memset( world->zone[j].name, 0, NAMESIZE );
              memset( world->zone[j].author, 0, NAMESIZE );

              pack_fread( &l, 4, fh );
              pack_fread( world->zone[j].name, l, fh );
       
              pack_fread( &l, 4, fh );
              pack_fread( world->zone[j].author, l, fh );
       
              pack_fread( &world->zone[j].tint, 4, fh );
              pack_fread( &world->zone[j].vnum, 4, fh );
              pack_fread( &world->zone[j].life_span, 4, fh );
              pack_fread( &world->zone[j].reset_mode, 4, fh );
       
              pack_fread( &world->zone[j].stype, 4, fh );
              pack_fread( &world->zone[j].rbv, 8, fh );
       
              pack_fread( &world->zone[j].num_rooms, 4, fh );
              pack_fread( &world->zone[j].last_room_vnum, 4, fh );
              world->zone[j].room = malloc( sizeof(ROOM) * world->zone[j].num_rooms );
              for( k = 0; k < world->zone[j].num_rooms; k++ ){
                 world->zone[j].room[k].title = malloc( NAMESIZE );
                 world->zone[j].room[k].desc = malloc( RDSIZE );

                 memset( world->zone[j].room[k].title, 0, NAMESIZE );
                 memset( world->zone[j].room[k].desc, 0, RDSIZE );

                 pack_fread( &world->zone[j].room[k].x, 4, fh );
                 pack_fread( &world->zone[j].room[k].y, 4, fh );
                 pack_fread( &world->zone[j].room[k].z, 4, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].room[k].title, l, fh );
          
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].room[k].desc, l, fh );
          
                 pack_fread( &world->zone[j].room[k].vnum, 4, fh );
                 pack_fread( &world->zone[j].room[k].zone, 4, fh );
                 pack_fread( &world->zone[j].room[k].rbv, 8, fh );
                 pack_fread( &world->zone[j].room[k].stype, 4, fh );
       
                 pack_fread( &world->zone[j].room[k].num_doors, 4, fh );
                 world->zone[j].room[k].door = malloc( sizeof(DOOR) * world->zone[j].room[k].num_doors );
                 for( l = 0; l < world->zone[j].room[k].num_doors; l++ ){
                    world->zone[j].room[k].door[l].desc = malloc( RDSIZE );
                    world->zone[j].room[k].door[l].keywords = malloc( NAMESIZE );

                    memset( world->zone[j].room[k].door[l].desc, 0, RDSIZE );
                    memset( world->zone[j].room[k].door[l].keywords, 0, NAMESIZE );

                    pack_fread( &world->zone[j].room[k].door[l].croom, 4, fh );
                    pack_fread( &world->zone[j].room[k].door[l].czone, 4, fh );
                    pack_fread( &world->zone[j].room[k].door[l].cdir, 4, fh );
                    pack_fread( &world->zone[j].room[k].door[l].flags, 4, fh );
                    pack_fread( &world->zone[j].room[k].door[l].dir, 4, fh );
       
                    pack_fread( &m, 4, fh );
                    pack_fread( world->zone[j].room[k].door[l].desc, m, fh );
       
                    pack_fread( &m, 4, fh );
                    pack_fread( world->zone[j].room[k].door[l].keywords, m, fh );
                    }
          
                 pack_fread( &world->zone[j].room[k].num_exd, 4, fh );
                 world->zone[j].room[k].exd = malloc( sizeof(EXD) * world->zone[j].room[k].num_exd );
                 for( l = 0; l < world->zone[j].room[k].num_exd; l++ ){
                    world->zone[j].room[k].exd[l].keywords = malloc( NAMESIZE );
                    world->zone[j].room[k].exd[l].desc = malloc( RDSIZE );

                    memset( world->zone[j].room[k].exd[l].keywords, 0, NAMESIZE );
                    memset( world->zone[j].room[k].exd[l].desc, 0, RDSIZE );

                    pack_fread( &m, 4, fh );
                    pack_fread( world->zone[j].room[k].exd[l].keywords, m, fh );
          
                    pack_fread( &m, 4, fh );
                    pack_fread( world->zone[j].room[k].exd[l].desc, m, fh );
                    }
                 world->zone[j].room[k].num_cont = 0;
                 world->zone[j].room[k].content = malloc( 1 );
                 }
       
              pack_fread( &world->zone[j].num_objects, 4, fh );
              pack_fread( &world->zone[j].last_object_vnum, 4, fh );
              world->zone[j].object = malloc( sizeof(OBJECT) * world->zone[j].num_objects );
              for( k = 0; k < world->zone[j].num_objects; k++ ){
                 world->zone[j].object[k].keywords = malloc( NAMESIZE );
                 world->zone[j].object[k].short_desc = malloc( NAMESIZE );
                 world->zone[j].object[k].long_desc = malloc( NAMESIZE );
                 world->zone[j].object[k].action_desc = malloc( NAMESIZE );

                 memset( world->zone[j].object[k].keywords, 0, NAMESIZE );
                 memset( world->zone[j].object[k].short_desc, 0, NAMESIZE );
                 memset( world->zone[j].object[k].long_desc, 0, NAMESIZE );
                 memset( world->zone[j].object[k].action_desc, 0, NAMESIZE );

                 pack_fread( &world->zone[j].object[k].vnum, 4, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].keywords, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].short_desc, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].long_desc, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].action_desc, l, fh );
       
                 pack_fread( &world->zone[j].object[k].type, 4, fh );
                 pack_fread( &world->zone[j].object[k].ebv, 8, fh );
                 pack_fread( &world->zone[j].object[k].wbv, 8, fh );
                 pack_fread( world->zone[j].object[k].value, 16, fh );
                 pack_fread( &world->zone[j].object[k].weight, 4, fh );
                 pack_fread( &world->zone[j].object[k].cost, 4, fh );
                 pack_fread( &world->zone[j].object[k].rpd, 4, fh );
                 pack_fread( &world->zone[j].object[k].num_exd, 4, fh );
                 world->zone[j].object[k].exd = malloc( sizeof(EXD) * world->zone[j].object[k].num_exd );
                 for( m = 0; m < world->zone[j].object[k].num_exd; m++ ){
                    world->zone[j].object[k].exd[m].keywords = malloc( NAMESIZE );
                    world->zone[j].object[k].exd[m].desc = malloc( RDSIZE );

                    memset( world->zone[j].object[k].exd[m].keywords, 0, NAMESIZE );
                    memset( world->zone[j].object[k].exd[m].desc, 0, RDSIZE );

                    pack_fread( &l, 4, fh );
                    pack_fread( world->zone[j].object[k].exd[m].keywords, l, fh );
       
                    pack_fread( &l, 4, fh );
                    pack_fread( world->zone[j].object[k].exd[m].desc, l, fh );
                    }
                 pack_fread( &world->zone[j].object[k].num_affect, 4, fh );
                 world->zone[j].object[k].affect = malloc( sizeof(OAFFECT) * world->zone[j].object[k].num_affect );
                 for( m = 0; m < world->zone[j].object[k].num_affect; m++ ){
                    pack_fread( &world->zone[j].object[k].affect[m].location, 4, fh );
                    pack_fread( &world->zone[j].object[k].affect[m].value, 4, fh );
                    }
                 }
       
              pack_fread( &world->zone[j].num_mobiles, 4, fh );
              pack_fread( &world->zone[j].last_mobile_vnum, 4, fh );
              world->zone[j].mobile = malloc( sizeof(MOBILE) * world->zone[j].num_mobiles );
              for( k = 0; k < world->zone[j].num_mobiles; k++ ){
                 world->zone[j].mobile[k].keywords = malloc( NAMESIZE );
                 world->zone[j].mobile[k].short_desc = malloc( NAMESIZE );
                 world->zone[j].mobile[k].long_desc = malloc( NAMESIZE );
                 world->zone[j].mobile[k].detail_desc = malloc( RDSIZE );

                 memset( world->zone[j].mobile[k].keywords, 0, NAMESIZE );
                 memset( world->zone[j].mobile[k].short_desc, 0, NAMESIZE );
                 memset( world->zone[j].mobile[k].long_desc, 0, NAMESIZE );
                 memset( world->zone[j].mobile[k].detail_desc, 0, RDSIZE );

                 pack_fread( &world->zone[j].mobile[k].vnum, 4, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].mobile[k].keywords, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].mobile[k].short_desc, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].mobile[k].long_desc, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].mobile[k].detail_desc, l, fh );
       
                 pack_fread( &world->zone[j].mobile[k].actbv, 8, fh );
                 pack_fread( &world->zone[j].mobile[k].affbv, 8, fh );
                 pack_fread( &world->zone[j].mobile[k].alignment, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].typeflag, 1, fh );
                 pack_fread( &world->zone[j].mobile[k].level, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].thac0, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].ac, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].mhpx, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].mhpy, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].mhpz, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].bhdx, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].bhdy, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].bhdz, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].gold, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].exp, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].loadpos, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].defpos, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].sex, 1, fh );
                 pack_fread( &world->zone[j].mobile[k].num_especs, 4, fh );
                 world->zone[j].mobile[k].espec = malloc( sizeof(ESPEC) * world->zone[j].mobile[k].num_especs );
                 pack_fread( world->zone[j].mobile[k].espec, sizeof(ESPEC)*world->zone[j].mobile[k].num_especs, fh );
                 }

              world->zone[j].num_shops = 0;
              world->zone[j].shop = malloc( 1 );
              world->zone[j].last_shop_vnum = -1;

              pack_fread( &world->zone[j].num_tags, 4, fh );
              world->zone[j].tag = malloc( sizeof(TAG) * world->zone[j].num_tags );
              for( k = 0; k < world->zone[j].num_tags; k++ ){
                 world->zone[j].tag[k].str = malloc( NAMESIZE );

                 memset( world->zone[j].tag[k].str, 0, NAMESIZE );

                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].tag[k].str, l, fh );
          
                 pack_fread( &world->zone[j].tag[k].x, 4, fh );
                 pack_fread( &world->zone[j].tag[k].y, 4, fh );
                 pack_fread( &world->zone[j].tag[k].z, 4, fh );
                 }
              }
           pack_fclose( fh );
           rehash_world( world );
           break;

      case (1<<16)|14:
           pack_fread( &world->num_zones, 4, fh );
           pack_fread( &world->last_zone_vnum, 4, fh );
           world->zone = malloc( sizeof(ZONE) * world->num_zones );
           for( j = 0; j < world->num_zones; j++ ){
              world->zone[j].name = malloc( NAMESIZE );
              world->zone[j].author = malloc( NAMESIZE );

              memset( world->zone[j].name, 0, NAMESIZE );
              memset( world->zone[j].author, 0, NAMESIZE );

              pack_fread( &l, 4, fh );
              pack_fread( world->zone[j].name, l, fh );
       
              pack_fread( &l, 4, fh );
              pack_fread( world->zone[j].author, l, fh );
       
              pack_fread( &world->zone[j].tint, 4, fh );
              pack_fread( &world->zone[j].vnum, 4, fh );
              pack_fread( &world->zone[j].life_span, 4, fh );
              pack_fread( &world->zone[j].reset_mode, 4, fh );
       
              pack_fread( &world->zone[j].stype, 4, fh );
              pack_fread( &world->zone[j].rbv, 8, fh );
       
              pack_fread( &world->zone[j].num_rooms, 4, fh );
              pack_fread( &world->zone[j].last_room_vnum, 4, fh );
              world->zone[j].room = malloc( sizeof(ROOM) * world->zone[j].num_rooms );
              for( k = 0; k < world->zone[j].num_rooms; k++ ){
                 world->zone[j].room[k].title = malloc( NAMESIZE );
                 world->zone[j].room[k].desc = malloc( RDSIZE );

                 memset( world->zone[j].room[k].title, 0, NAMESIZE );
                 memset( world->zone[j].room[k].desc, 0, RDSIZE );

                 pack_fread( &world->zone[j].room[k].x, 4, fh );
                 pack_fread( &world->zone[j].room[k].y, 4, fh );
                 pack_fread( &world->zone[j].room[k].z, 4, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].room[k].title, l, fh );
          
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].room[k].desc, l, fh );
          
                 pack_fread( &world->zone[j].room[k].vnum, 4, fh );
                 pack_fread( &world->zone[j].room[k].zone, 4, fh );
                 pack_fread( &world->zone[j].room[k].rbv, 8, fh );
                 pack_fread( &world->zone[j].room[k].stype, 4, fh );
       
                 pack_fread( &world->zone[j].room[k].num_doors, 4, fh );
                 world->zone[j].room[k].door = malloc( sizeof(DOOR) * world->zone[j].room[k].num_doors );
                 for( l = 0; l < world->zone[j].room[k].num_doors; l++ ){
                    world->zone[j].room[k].door[l].desc = malloc( RDSIZE );
                    world->zone[j].room[k].door[l].keywords = malloc( NAMESIZE );

                    memset( world->zone[j].room[k].door[l].desc, 0, RDSIZE );
                    memset( world->zone[j].room[k].door[l].keywords, 0, NAMESIZE );

                    pack_fread( &world->zone[j].room[k].door[l].croom, 4, fh );
                    pack_fread( &world->zone[j].room[k].door[l].czone, 4, fh );
                    pack_fread( &world->zone[j].room[k].door[l].cdir, 4, fh );
                    pack_fread( &world->zone[j].room[k].door[l].flags, 4, fh );
                    pack_fread( &world->zone[j].room[k].door[l].dir, 4, fh );
       
                    pack_fread( &m, 4, fh );
                    pack_fread( world->zone[j].room[k].door[l].desc, m, fh );
       
                    pack_fread( &m, 4, fh );
                    pack_fread( world->zone[j].room[k].door[l].keywords, m, fh );
                    }
          
                 pack_fread( &world->zone[j].room[k].num_exd, 4, fh );
                 world->zone[j].room[k].exd = malloc( sizeof(EXD) * world->zone[j].room[k].num_exd );
                 for( l = 0; l < world->zone[j].room[k].num_exd; l++ ){
                    world->zone[j].room[k].exd[l].keywords = malloc( NAMESIZE );
                    world->zone[j].room[k].exd[l].desc = malloc( RDSIZE );

                    memset( world->zone[j].room[k].exd[l].keywords, 0, NAMESIZE );
                    memset( world->zone[j].room[k].exd[l].desc, 0, RDSIZE );

                    pack_fread( &m, 4, fh );
                    pack_fread( world->zone[j].room[k].exd[l].keywords, m, fh );
          
                    pack_fread( &m, 4, fh );
                    pack_fread( world->zone[j].room[k].exd[l].desc, m, fh );
                    }
                 world->zone[j].room[k].num_cont = 0;
                 world->zone[j].room[k].content = malloc( 1 );
                 }
       
              pack_fread( &world->zone[j].num_objects, 4, fh );
              pack_fread( &world->zone[j].last_object_vnum, 4, fh );
              world->zone[j].object = malloc( sizeof(OBJECT) * world->zone[j].num_objects );
              for( k = 0; k < world->zone[j].num_objects; k++ ){
                 world->zone[j].object[k].keywords = malloc( NAMESIZE );
                 world->zone[j].object[k].short_desc = malloc( NAMESIZE );
                 world->zone[j].object[k].long_desc = malloc( NAMESIZE );
                 world->zone[j].object[k].action_desc = malloc( NAMESIZE );

                 memset( world->zone[j].object[k].keywords, 0, NAMESIZE );
                 memset( world->zone[j].object[k].short_desc, 0, NAMESIZE );
                 memset( world->zone[j].object[k].long_desc, 0, NAMESIZE );
                 memset( world->zone[j].object[k].action_desc, 0, NAMESIZE );

                 pack_fread( &world->zone[j].object[k].vnum, 4, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].keywords, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].short_desc, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].long_desc, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].action_desc, l, fh );
       
                 pack_fread( &world->zone[j].object[k].type, 4, fh );
                 pack_fread( &world->zone[j].object[k].ebv, 8, fh );
                 pack_fread( &world->zone[j].object[k].wbv, 8, fh );
                 pack_fread( world->zone[j].object[k].value, 16, fh );
                 pack_fread( &world->zone[j].object[k].weight, 4, fh );
                 pack_fread( &world->zone[j].object[k].cost, 4, fh );
                 pack_fread( &world->zone[j].object[k].rpd, 4, fh );
                 pack_fread( &world->zone[j].object[k].num_exd, 4, fh );
                 world->zone[j].object[k].exd = malloc( sizeof(EXD) * world->zone[j].object[k].num_exd );
                 for( m = 0; m < world->zone[j].object[k].num_exd; m++ ){
                    world->zone[j].object[k].exd[m].keywords = malloc( NAMESIZE );
                    world->zone[j].object[k].exd[m].desc = malloc( RDSIZE );

                    memset( world->zone[j].object[k].exd[m].keywords, 0, NAMESIZE );
                    memset( world->zone[j].object[k].exd[m].desc, 0, RDSIZE );

                    pack_fread( &l, 4, fh );
                    pack_fread( world->zone[j].object[k].exd[m].keywords, l, fh );
       
                    pack_fread( &l, 4, fh );
                    pack_fread( world->zone[j].object[k].exd[m].desc, l, fh );
                    }
                 pack_fread( &world->zone[j].object[k].num_affect, 4, fh );
                 world->zone[j].object[k].affect = malloc( sizeof(OAFFECT) * world->zone[j].object[k].num_affect );
                 for( m = 0; m < world->zone[j].object[k].num_affect; m++ ){
                    pack_fread( &world->zone[j].object[k].affect[m].location, 4, fh );
                    pack_fread( &world->zone[j].object[k].affect[m].value, 4, fh );
                    }
                 }
       
              pack_fread( &world->zone[j].num_mobiles, 4, fh );
              pack_fread( &world->zone[j].last_mobile_vnum, 4, fh );
              world->zone[j].mobile = malloc( sizeof(MOBILE) * world->zone[j].num_mobiles );
              for( k = 0; k < world->zone[j].num_mobiles; k++ ){
                 world->zone[j].mobile[k].keywords = malloc( NAMESIZE );
                 world->zone[j].mobile[k].short_desc = malloc( NAMESIZE );
                 world->zone[j].mobile[k].long_desc = malloc( NAMESIZE );
                 world->zone[j].mobile[k].detail_desc = malloc( RDSIZE );

                 memset( world->zone[j].mobile[k].keywords, 0, NAMESIZE );
                 memset( world->zone[j].mobile[k].short_desc, 0, NAMESIZE );
                 memset( world->zone[j].mobile[k].long_desc, 0, NAMESIZE );
                 memset( world->zone[j].mobile[k].detail_desc, 0, RDSIZE );

                 pack_fread( &world->zone[j].mobile[k].vnum, 4, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].mobile[k].keywords, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].mobile[k].short_desc, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].mobile[k].long_desc, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].mobile[k].detail_desc, l, fh );
       
                 pack_fread( &world->zone[j].mobile[k].actbv, 8, fh );
                 pack_fread( &world->zone[j].mobile[k].affbv, 8, fh );
                 pack_fread( &world->zone[j].mobile[k].alignment, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].typeflag, 1, fh );
                 pack_fread( &world->zone[j].mobile[k].level, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].thac0, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].ac, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].mhpx, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].mhpy, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].mhpz, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].bhdx, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].bhdy, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].bhdz, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].gold, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].exp, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].loadpos, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].defpos, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].sex, 1, fh );
                 pack_fread( &world->zone[j].mobile[k].num_especs, 4, fh );
                 world->zone[j].mobile[k].espec = malloc( sizeof(ESPEC) * world->zone[j].mobile[k].num_especs );
                 pack_fread( world->zone[j].mobile[k].espec, sizeof(ESPEC)*world->zone[j].mobile[k].num_especs, fh );
                 }

              pack_fread( &world->zone[j].num_shops, 4, fh );
              world->zone[j].shop = malloc( sizeof(SHOP)*world->zone[j].num_shops );
              pack_fread( &world->zone[j].last_shop_vnum, 4, fh );
              for( k = 0; k < world->zone[j].num_shops; k++ ){
                 world->zone[j].shop[k].buy_item_ne = malloc( NAMESIZE );
                 memset( world->zone[j].shop[k].buy_item_ne, 0, NAMESIZE );

                 world->zone[j].shop[k].sell_item_ne = malloc( NAMESIZE );
                 memset( world->zone[j].shop[k].sell_item_ne, 0, NAMESIZE );

                 world->zone[j].shop[k].refuse_offer = malloc( NAMESIZE );
                 memset( world->zone[j].shop[k].refuse_offer, 0, NAMESIZE );

                 world->zone[j].shop[k].shop_afford = malloc( NAMESIZE );
                 memset( world->zone[j].shop[k].shop_afford, 0, NAMESIZE );

                 world->zone[j].shop[k].play_afford = malloc( NAMESIZE );
                 memset( world->zone[j].shop[k].play_afford, 0, NAMESIZE );

                 world->zone[j].shop[k].buy_success = malloc( NAMESIZE );
                 memset( world->zone[j].shop[k].buy_success, 0, NAMESIZE );

                 world->zone[j].shop[k].sell_success = malloc( NAMESIZE );
                 memset( world->zone[j].shop[k].sell_success, 0, NAMESIZE );

                 pack_fread( &world->zone[j].shop[k].vnum, 4, fh );
       
                 pack_fread( &world->zone[j].shop[k].num_items, 4, fh );
                 world->zone[j].shop[k].item = malloc( 4*world->zone[j].shop[k].num_items );
                 pack_fread( world->zone[j].shop[k].item, 4*world->zone[j].shop[k].num_items, fh );
       
                 pack_fread( &world->zone[j].shop[k].prof_sell, 4, fh );
                 pack_fread( &world->zone[j].shop[k].prof_buy, 4, fh );
       
                 pack_fread( &world->zone[j].shop[k].num_bspecs, 4, fh );
                 world->zone[j].shop[k].bspec = malloc( sizeof(BSPEC)*world->zone[j].shop[k].num_bspecs );
                 for( l = 0; l < world->zone[j].shop[k].num_bspecs; l++ ){
                    world->zone[j].shop[k].bspec[l].namelist = malloc( NAMESIZE );
                    memset( world->zone[j].shop[k].bspec[l].namelist, 0, NAMESIZE );

                    pack_fread( &world->zone[j].shop[k].bspec[l].type, 4, fh );
       
                    pack_fread( &t, 4, fh );
                    pack_fread( world->zone[j].shop[k].bspec[l].namelist, t, fh );
                    }
       
                 pack_fread( &t, 4, fh );
                 pack_fread( world->zone[j].shop[k].buy_item_ne, t, fh );
       
                 pack_fread( &t, 4, fh );
                 pack_fread( world->zone[j].shop[k].sell_item_ne, t, fh );
       
                 pack_fread( &t, 4, fh );
                 pack_fread( world->zone[j].shop[k].refuse_offer, t, fh );
       
                 pack_fread( &t, 4, fh );
                 pack_fread( world->zone[j].shop[k].shop_afford, t, fh );
       
                 pack_fread( &t, 4, fh );
                 pack_fread( world->zone[j].shop[k].play_afford, t, fh );
       
                 pack_fread( &t, 4, fh );
                 pack_fread( world->zone[j].shop[k].buy_success, t, fh );
       
                 pack_fread( &t, 4, fh );
                 pack_fread( world->zone[j].shop[k].sell_success, t, fh );
       
                 pack_fread( &world->zone[j].shop[k].temper, 4, fh );
                 pack_fread( &world->zone[j].shop[k].shop_bv, 8, fh );
                 pack_fread( &world->zone[j].shop[k].mobile, 4, fh );
                 pack_fread( &world->zone[j].shop[k].withwho_bv, 8, fh );
       
                 pack_fread( &world->zone[j].shop[k].num_rooms, 4, fh );
                 world->zone[j].shop[k].room = malloc( 4*world->zone[j].shop[k].num_rooms );
                 pack_fread( world->zone[j].shop[k].room, 4*world->zone[j].shop[k].num_rooms, fh );
       
                 pack_fread( &world->zone[j].shop[k].topen[0], 4, fh );
                 pack_fread( &world->zone[j].shop[k].tclose[0], 4, fh );
                 pack_fread( &world->zone[j].shop[k].topen[1], 4, fh );
                 pack_fread( &world->zone[j].shop[k].tclose[1], 4, fh );
                 }

              pack_fread( &world->zone[j].num_tags, 4, fh );
              world->zone[j].tag = malloc( sizeof(TAG) * world->zone[j].num_tags );
              for( k = 0; k < world->zone[j].num_tags; k++ ){
                 world->zone[j].tag[k].str = malloc( NAMESIZE );

                 memset( world->zone[j].tag[k].str, 0, NAMESIZE );

                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].tag[k].str, l, fh );
          
                 pack_fread( &world->zone[j].tag[k].x, 4, fh );
                 pack_fread( &world->zone[j].tag[k].y, 4, fh );
                 pack_fread( &world->zone[j].tag[k].z, 4, fh );
                 }
              }
           pack_fclose( fh );
           rehash_world( world );
           break;

      case (1<<16)|15:
           pack_fread( &world->num_zones, 4, fh );
           pack_fread( &world->last_zone_vnum, 4, fh );
           world->zone = malloc( sizeof(ZONE) * world->num_zones );
           for( j = 0; j < world->num_zones; j++ ){
              world->zone[j].name = malloc( NAMESIZE );
              world->zone[j].author = malloc( NAMESIZE );

              memset( world->zone[j].name, 0, NAMESIZE );
              memset( world->zone[j].author, 0, NAMESIZE );

              pack_fread( &l, 4, fh );
              pack_fread( world->zone[j].name, l, fh );
       
              pack_fread( &l, 4, fh );
              pack_fread( world->zone[j].author, l, fh );
       
              pack_fread( &world->zone[j].tint, 4, fh );
              pack_fread( &world->zone[j].vnum, 4, fh );
              pack_fread( &world->zone[j].life_span, 4, fh );
              pack_fread( &world->zone[j].reset_mode, 4, fh );
       
              pack_fread( &world->zone[j].stype, 4, fh );
              pack_fread( &world->zone[j].rbv, 8, fh );
       
              pack_fread( &world->zone[j].num_rooms, 4, fh );
              pack_fread( &world->zone[j].last_room_vnum, 4, fh );
              world->zone[j].room = malloc( sizeof(ROOM) * world->zone[j].num_rooms );
              for( k = 0; k < world->zone[j].num_rooms; k++ ){
                 world->zone[j].room[k].title = malloc( NAMESIZE );
                 world->zone[j].room[k].desc = malloc( RDSIZE );

                 memset( world->zone[j].room[k].title, 0, NAMESIZE );
                 memset( world->zone[j].room[k].desc, 0, RDSIZE );

                 pack_fread( &world->zone[j].room[k].x, 4, fh );
                 pack_fread( &world->zone[j].room[k].y, 4, fh );
                 pack_fread( &world->zone[j].room[k].z, 4, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].room[k].title, l, fh );
          
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].room[k].desc, l, fh );
          
                 pack_fread( &world->zone[j].room[k].vnum, 4, fh );
                 pack_fread( &world->zone[j].room[k].zone, 4, fh );
                 pack_fread( &world->zone[j].room[k].rbv, 8, fh );
                 pack_fread( &world->zone[j].room[k].stype, 4, fh );
       
                 pack_fread( &world->zone[j].room[k].num_doors, 4, fh );
                 world->zone[j].room[k].door = malloc( sizeof(DOOR) * world->zone[j].room[k].num_doors );
                 for( l = 0; l < world->zone[j].room[k].num_doors; l++ ){
                    world->zone[j].room[k].door[l].desc = malloc( RDSIZE );
                    world->zone[j].room[k].door[l].keywords = malloc( NAMESIZE );

                    memset( world->zone[j].room[k].door[l].desc, 0, RDSIZE );
                    memset( world->zone[j].room[k].door[l].keywords, 0, NAMESIZE );

                    pack_fread( &world->zone[j].room[k].door[l].croom, 4, fh );
                    pack_fread( &world->zone[j].room[k].door[l].czone, 4, fh );
                    pack_fread( &world->zone[j].room[k].door[l].cdir, 4, fh );
                    pack_fread( &world->zone[j].room[k].door[l].flags, 4, fh );
                    pack_fread( &world->zone[j].room[k].door[l].dir, 4, fh );
       
                    pack_fread( &m, 4, fh );
                    pack_fread( world->zone[j].room[k].door[l].desc, m, fh );
       
                    pack_fread( &m, 4, fh );
                    pack_fread( world->zone[j].room[k].door[l].keywords, m, fh );
                    }
          
                 pack_fread( &world->zone[j].room[k].num_exd, 4, fh );
                 world->zone[j].room[k].exd = malloc( sizeof(EXD) * world->zone[j].room[k].num_exd );
                 for( l = 0; l < world->zone[j].room[k].num_exd; l++ ){
                    world->zone[j].room[k].exd[l].keywords = malloc( NAMESIZE );
                    world->zone[j].room[k].exd[l].desc = malloc( RDSIZE );

                    memset( world->zone[j].room[k].exd[l].keywords, 0, NAMESIZE );
                    memset( world->zone[j].room[k].exd[l].desc, 0, RDSIZE );

                    pack_fread( &m, 4, fh );
                    pack_fread( world->zone[j].room[k].exd[l].keywords, m, fh );
          
                    pack_fread( &m, 4, fh );
                    pack_fread( world->zone[j].room[k].exd[l].desc, m, fh );
                    }

                 pack_fread( &world->zone[j].room[k].num_cont, 4, fh );
                 world->zone[j].room[k].content = malloc( sizeof(RCONTENT)*world->zone[j].room[k].num_cont );
                 pack_fread( world->zone[j].room[k].content, sizeof(RCONTENT)*world->zone[j].room[k].num_cont, fh );
                 }
       
              pack_fread( &world->zone[j].num_objects, 4, fh );
              pack_fread( &world->zone[j].last_object_vnum, 4, fh );
              world->zone[j].object = malloc( sizeof(OBJECT) * world->zone[j].num_objects );
              for( k = 0; k < world->zone[j].num_objects; k++ ){
                 world->zone[j].object[k].keywords = malloc( NAMESIZE );
                 world->zone[j].object[k].short_desc = malloc( NAMESIZE );
                 world->zone[j].object[k].long_desc = malloc( NAMESIZE );
                 world->zone[j].object[k].action_desc = malloc( NAMESIZE );

                 memset( world->zone[j].object[k].keywords, 0, NAMESIZE );
                 memset( world->zone[j].object[k].short_desc, 0, NAMESIZE );
                 memset( world->zone[j].object[k].long_desc, 0, NAMESIZE );
                 memset( world->zone[j].object[k].action_desc, 0, NAMESIZE );

                 pack_fread( &world->zone[j].object[k].vnum, 4, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].keywords, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].short_desc, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].long_desc, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].action_desc, l, fh );
       
                 pack_fread( &world->zone[j].object[k].type, 4, fh );
                 pack_fread( &world->zone[j].object[k].ebv, 8, fh );
                 pack_fread( &world->zone[j].object[k].wbv, 8, fh );
                 pack_fread( world->zone[j].object[k].value, 16, fh );
                 pack_fread( &world->zone[j].object[k].weight, 4, fh );
                 pack_fread( &world->zone[j].object[k].cost, 4, fh );
                 pack_fread( &world->zone[j].object[k].rpd, 4, fh );
                 pack_fread( &world->zone[j].object[k].num_exd, 4, fh );
                 world->zone[j].object[k].exd = malloc( sizeof(EXD) * world->zone[j].object[k].num_exd );
                 for( m = 0; m < world->zone[j].object[k].num_exd; m++ ){
                    world->zone[j].object[k].exd[m].keywords = malloc( NAMESIZE );
                    world->zone[j].object[k].exd[m].desc = malloc( RDSIZE );

                    memset( world->zone[j].object[k].exd[m].keywords, 0, NAMESIZE );
                    memset( world->zone[j].object[k].exd[m].desc, 0, RDSIZE );

                    pack_fread( &l, 4, fh );
                    pack_fread( world->zone[j].object[k].exd[m].keywords, l, fh );
       
                    pack_fread( &l, 4, fh );
                    pack_fread( world->zone[j].object[k].exd[m].desc, l, fh );
                    }
                 pack_fread( &world->zone[j].object[k].num_affect, 4, fh );
                 world->zone[j].object[k].affect = malloc( sizeof(OAFFECT) * world->zone[j].object[k].num_affect );
                 for( m = 0; m < world->zone[j].object[k].num_affect; m++ ){
                    pack_fread( &world->zone[j].object[k].affect[m].location, 4, fh );
                    pack_fread( &world->zone[j].object[k].affect[m].value, 4, fh );
                    }
                 }
       
              pack_fread( &world->zone[j].num_mobiles, 4, fh );
              pack_fread( &world->zone[j].last_mobile_vnum, 4, fh );
              world->zone[j].mobile = malloc( sizeof(MOBILE) * world->zone[j].num_mobiles );
              for( k = 0; k < world->zone[j].num_mobiles; k++ ){
                 world->zone[j].mobile[k].keywords = malloc( NAMESIZE );
                 world->zone[j].mobile[k].short_desc = malloc( NAMESIZE );
                 world->zone[j].mobile[k].long_desc = malloc( NAMESIZE );
                 world->zone[j].mobile[k].detail_desc = malloc( RDSIZE );

                 memset( world->zone[j].mobile[k].keywords, 0, NAMESIZE );
                 memset( world->zone[j].mobile[k].short_desc, 0, NAMESIZE );
                 memset( world->zone[j].mobile[k].long_desc, 0, NAMESIZE );
                 memset( world->zone[j].mobile[k].detail_desc, 0, RDSIZE );

                 pack_fread( &world->zone[j].mobile[k].vnum, 4, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].mobile[k].keywords, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].mobile[k].short_desc, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].mobile[k].long_desc, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].mobile[k].detail_desc, l, fh );
       
                 pack_fread( &world->zone[j].mobile[k].actbv, 8, fh );
                 pack_fread( &world->zone[j].mobile[k].affbv, 8, fh );
                 pack_fread( &world->zone[j].mobile[k].alignment, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].typeflag, 1, fh );
                 pack_fread( &world->zone[j].mobile[k].level, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].thac0, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].ac, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].mhpx, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].mhpy, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].mhpz, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].bhdx, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].bhdy, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].bhdz, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].gold, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].exp, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].loadpos, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].defpos, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].sex, 1, fh );
                 pack_fread( &world->zone[j].mobile[k].num_especs, 4, fh );
                 world->zone[j].mobile[k].espec = malloc( sizeof(ESPEC) * world->zone[j].mobile[k].num_especs );
                 pack_fread( world->zone[j].mobile[k].espec, sizeof(ESPEC)*world->zone[j].mobile[k].num_especs, fh );
                 }

              pack_fread( &world->zone[j].num_shops, 4, fh );
              world->zone[j].shop = malloc( sizeof(SHOP)*world->zone[j].num_shops );
              pack_fread( &world->zone[j].last_shop_vnum, 4, fh );
              for( k = 0; k < world->zone[j].num_shops; k++ ){
                 world->zone[j].shop[k].buy_item_ne = malloc( NAMESIZE );
                 memset( world->zone[j].shop[k].buy_item_ne, 0, NAMESIZE );

                 world->zone[j].shop[k].sell_item_ne = malloc( NAMESIZE );
                 memset( world->zone[j].shop[k].sell_item_ne, 0, NAMESIZE );

                 world->zone[j].shop[k].refuse_offer = malloc( NAMESIZE );
                 memset( world->zone[j].shop[k].refuse_offer, 0, NAMESIZE );

                 world->zone[j].shop[k].shop_afford = malloc( NAMESIZE );
                 memset( world->zone[j].shop[k].shop_afford, 0, NAMESIZE );

                 world->zone[j].shop[k].play_afford = malloc( NAMESIZE );
                 memset( world->zone[j].shop[k].play_afford, 0, NAMESIZE );

                 world->zone[j].shop[k].buy_success = malloc( NAMESIZE );
                 memset( world->zone[j].shop[k].buy_success, 0, NAMESIZE );

                 world->zone[j].shop[k].sell_success = malloc( NAMESIZE );
                 memset( world->zone[j].shop[k].sell_success, 0, NAMESIZE );

                 pack_fread( &world->zone[j].shop[k].vnum, 4, fh );
       
                 pack_fread( &world->zone[j].shop[k].num_items, 4, fh );
                 world->zone[j].shop[k].item = malloc( 4*world->zone[j].shop[k].num_items );
                 pack_fread( world->zone[j].shop[k].item, 4*world->zone[j].shop[k].num_items, fh );
       
                 pack_fread( &world->zone[j].shop[k].prof_sell, 4, fh );
                 pack_fread( &world->zone[j].shop[k].prof_buy, 4, fh );
       
                 pack_fread( &world->zone[j].shop[k].num_bspecs, 4, fh );
                 world->zone[j].shop[k].bspec = malloc( sizeof(BSPEC)*world->zone[j].shop[k].num_bspecs );
                 for( l = 0; l < world->zone[j].shop[k].num_bspecs; l++ ){
                    world->zone[j].shop[k].bspec[l].namelist = malloc( NAMESIZE );
                    memset( world->zone[j].shop[k].bspec[l].namelist, 0, NAMESIZE );

                    pack_fread( &world->zone[j].shop[k].bspec[l].type, 4, fh );
       
                    pack_fread( &t, 4, fh );
                    pack_fread( world->zone[j].shop[k].bspec[l].namelist, t, fh );
                    }
       
                 pack_fread( &t, 4, fh );
                 pack_fread( world->zone[j].shop[k].buy_item_ne, t, fh );
       
                 pack_fread( &t, 4, fh );
                 pack_fread( world->zone[j].shop[k].sell_item_ne, t, fh );
       
                 pack_fread( &t, 4, fh );
                 pack_fread( world->zone[j].shop[k].refuse_offer, t, fh );
       
                 pack_fread( &t, 4, fh );
                 pack_fread( world->zone[j].shop[k].shop_afford, t, fh );
       
                 pack_fread( &t, 4, fh );
                 pack_fread( world->zone[j].shop[k].play_afford, t, fh );
       
                 pack_fread( &t, 4, fh );
                 pack_fread( world->zone[j].shop[k].buy_success, t, fh );
       
                 pack_fread( &t, 4, fh );
                 pack_fread( world->zone[j].shop[k].sell_success, t, fh );
       
                 pack_fread( &world->zone[j].shop[k].temper, 4, fh );
                 pack_fread( &world->zone[j].shop[k].shop_bv, 8, fh );
                 pack_fread( &world->zone[j].shop[k].mobile, 4, fh );
                 pack_fread( &world->zone[j].shop[k].withwho_bv, 8, fh );
       
                 pack_fread( &world->zone[j].shop[k].num_rooms, 4, fh );
                 world->zone[j].shop[k].room = malloc( 4*world->zone[j].shop[k].num_rooms );
                 pack_fread( world->zone[j].shop[k].room, 4*world->zone[j].shop[k].num_rooms, fh );
       
                 pack_fread( &world->zone[j].shop[k].topen[0], 4, fh );
                 pack_fread( &world->zone[j].shop[k].tclose[0], 4, fh );
                 pack_fread( &world->zone[j].shop[k].topen[1], 4, fh );
                 pack_fread( &world->zone[j].shop[k].tclose[1], 4, fh );
                 }

              pack_fread( &world->zone[j].num_tags, 4, fh );
              world->zone[j].tag = malloc( sizeof(TAG) * world->zone[j].num_tags );
              for( k = 0; k < world->zone[j].num_tags; k++ ){
                 world->zone[j].tag[k].str = malloc( NAMESIZE );

                 memset( world->zone[j].tag[k].str, 0, NAMESIZE );

                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].tag[k].str, l, fh );
          
                 pack_fread( &world->zone[j].tag[k].x, 4, fh );
                 pack_fread( &world->zone[j].tag[k].y, 4, fh );
                 pack_fread( &world->zone[j].tag[k].z, 4, fh );
                 }
              }
           pack_fclose( fh );
           rehash_world( world );
           break;

       default:
           pack_fclose( fh );
           return 0;
      }

    return ((ver<<16)|rev);
}

int save_world( char *fn, WORLD *world )
{
    PACKFILE *fh;
    unsigned short ver=YMW_CURRENT_VERSION, rev=YMW_CURRENT_REVISION;
    int j, k, l, m, t;

    if( (fh = pack_fopen( fn, "wb!" )) == NULL )
      return 0;
    pack_fwrite( &ver, 2, fh );
    pack_fwrite( &rev, 2, fh );
    pack_fwrite( &world->num_zones, 4, fh );
    pack_fwrite( &world->last_zone_vnum, 4, fh );
    for( j = 0; j < world->num_zones; j++ ){
       l = strlen( world->zone[j].name );
       pack_fwrite( &l, 4, fh );
       pack_fwrite( world->zone[j].name, l, fh );

       l = strlen( world->zone[j].author );
       pack_fwrite( &l, 4, fh );
       pack_fwrite( world->zone[j].author, l, fh );

       pack_fwrite( &world->zone[j].tint, 4, fh );
       pack_fwrite( &world->zone[j].vnum, 4, fh );
       pack_fwrite( &world->zone[j].life_span, 4, fh );
       pack_fwrite( &world->zone[j].reset_mode, 4, fh );

       pack_fwrite( &world->zone[j].stype, 4, fh );
       pack_fwrite( &world->zone[j].rbv, 8, fh );

       pack_fwrite( &world->zone[j].num_rooms, 4, fh );
       pack_fwrite( &world->zone[j].last_room_vnum, 4, fh );
       for( k = 0; k < world->zone[j].num_rooms; k++ ){
          pack_fwrite( &world->zone[j].room[k].x, 4, fh );
          pack_fwrite( &world->zone[j].room[k].y, 4, fh );
          pack_fwrite( &world->zone[j].room[k].z, 4, fh );

          l = strlen( world->zone[j].room[k].title );
          pack_fwrite( &l, 4, fh );
          pack_fwrite( world->zone[j].room[k].title, l, fh );
   
          l = strlen( world->zone[j].room[k].desc );
          pack_fwrite( &l, 4, fh );
          pack_fwrite( world->zone[j].room[k].desc, l, fh );
   
          pack_fwrite( &world->zone[j].room[k].vnum, 4, fh );
          pack_fwrite( &world->zone[j].room[k].zone, 4, fh );
          pack_fwrite( &world->zone[j].room[k].rbv, 8, fh );
          pack_fwrite( &world->zone[j].room[k].stype, 4, fh );

          pack_fwrite( &world->zone[j].room[k].num_doors, 4, fh );
          for( l = 0; l < world->zone[j].room[k].num_doors; l++ ){
             pack_fwrite( &world->zone[j].room[k].door[l].croom, 4, fh );
             pack_fwrite( &world->zone[j].room[k].door[l].czone, 4, fh );
             pack_fwrite( &world->zone[j].room[k].door[l].cdir, 4, fh );
             pack_fwrite( &world->zone[j].room[k].door[l].flags, 4, fh );
             pack_fwrite( &world->zone[j].room[k].door[l].dir, 4, fh );

             m = strlen( world->zone[j].room[k].door[l].desc );
             pack_fwrite( &m, 4, fh );
             pack_fwrite( world->zone[j].room[k].door[l].desc, m, fh );

             m = strlen( world->zone[j].room[k].door[l].keywords );
             pack_fwrite( &m, 4, fh );
             pack_fwrite( world->zone[j].room[k].door[l].keywords, m, fh );
             }
   
          pack_fwrite( &world->zone[j].room[k].num_exd, 4, fh );
          for( l = 0; l < world->zone[j].room[k].num_exd; l++ ){
             m = strlen( world->zone[j].room[k].exd[l].keywords );
             pack_fwrite( &m, 4, fh );
             pack_fwrite( world->zone[j].room[k].exd[l].keywords, m, fh );
   
             m = strlen( world->zone[j].room[k].exd[l].desc );
             pack_fwrite( &m, 4, fh );
             pack_fwrite( world->zone[j].room[k].exd[l].desc, m, fh );
             }

          pack_fwrite( &world->zone[j].room[k].num_cont, 4, fh );
          pack_fwrite( world->zone[j].room[k].content, sizeof(RCONTENT)*world->zone[j].room[k].num_cont, fh );
          }

       pack_fwrite( &world->zone[j].num_objects, 4, fh );
       pack_fwrite( &world->zone[j].last_object_vnum, 4, fh );
       for( k = 0; k < world->zone[j].num_objects; k++ ){
          pack_fwrite( &world->zone[j].object[k].vnum, 4, fh );

          l = strlen( world->zone[j].object[k].keywords );
          pack_fwrite( &l, 4, fh );
          pack_fwrite( world->zone[j].object[k].keywords, l, fh );

          l = strlen( world->zone[j].object[k].short_desc );
          pack_fwrite( &l, 4, fh );
          pack_fwrite( world->zone[j].object[k].short_desc, l, fh );

          l = strlen( world->zone[j].object[k].long_desc );
          pack_fwrite( &l, 4, fh );
          pack_fwrite( world->zone[j].object[k].long_desc, l, fh );

          l = strlen( world->zone[j].object[k].action_desc );
          pack_fwrite( &l, 4, fh );
          pack_fwrite( world->zone[j].object[k].action_desc, l, fh );

          pack_fwrite( &world->zone[j].object[k].type, 4, fh );
          pack_fwrite( &world->zone[j].object[k].ebv, 8, fh );
          pack_fwrite( &world->zone[j].object[k].wbv, 8, fh );
          pack_fwrite( world->zone[j].object[k].value, 16, fh );
          pack_fwrite( &world->zone[j].object[k].weight, 4, fh );
          pack_fwrite( &world->zone[j].object[k].cost, 4, fh );
          pack_fwrite( &world->zone[j].object[k].rpd, 4, fh );
          pack_fwrite( &world->zone[j].object[k].num_exd, 4, fh );
          for( m = 0; m < world->zone[j].object[k].num_exd; m++ ){
             l = strlen( world->zone[j].object[k].exd[m].keywords );
             pack_fwrite( &l, 4, fh );
             pack_fwrite( world->zone[j].object[k].exd[m].keywords, l, fh );

             l = strlen( world->zone[j].object[k].exd[m].desc );
             pack_fwrite( &l, 4, fh );
             pack_fwrite( world->zone[j].object[k].exd[m].desc, l, fh );
             }
          pack_fwrite( &world->zone[j].object[k].num_affect, 4, fh );
          for( m = 0; m < world->zone[j].object[k].num_affect; m++ ){
             pack_fwrite( &world->zone[j].object[k].affect[m].location, 4, fh );
             pack_fwrite( &world->zone[j].object[k].affect[m].value, 4, fh );
             }
          }

       pack_fwrite( &world->zone[j].num_mobiles, 4, fh );
       pack_fwrite( &world->zone[j].last_mobile_vnum, 4, fh );
       for( k = 0; k < world->zone[j].num_mobiles; k++ ){
          pack_fwrite( &world->zone[j].mobile[k].vnum, 4, fh );

          l = strlen( world->zone[j].mobile[k].keywords );
          pack_fwrite( &l, 4, fh );
          pack_fwrite( world->zone[j].mobile[k].keywords, l, fh );

          l = strlen( world->zone[j].mobile[k].short_desc );
          pack_fwrite( &l, 4, fh );
          pack_fwrite( world->zone[j].mobile[k].short_desc, l, fh );

          l = strlen( world->zone[j].mobile[k].long_desc );
          pack_fwrite( &l, 4, fh );
          pack_fwrite( world->zone[j].mobile[k].long_desc, l, fh );

          l = strlen( world->zone[j].mobile[k].detail_desc );
          pack_fwrite( &l, 4, fh );
          pack_fwrite( world->zone[j].mobile[k].detail_desc, l, fh );

          pack_fwrite( &world->zone[j].mobile[k].actbv, 8, fh );
          pack_fwrite( &world->zone[j].mobile[k].affbv, 8, fh );
          pack_fwrite( &world->zone[j].mobile[k].alignment, 4, fh );
          pack_fwrite( &world->zone[j].mobile[k].typeflag, 1, fh );
          pack_fwrite( &world->zone[j].mobile[k].level, 4, fh );
          pack_fwrite( &world->zone[j].mobile[k].thac0, 4, fh );
          pack_fwrite( &world->zone[j].mobile[k].ac, 4, fh );
          pack_fwrite( &world->zone[j].mobile[k].mhpx, 4, fh );
          pack_fwrite( &world->zone[j].mobile[k].mhpy, 4, fh );
          pack_fwrite( &world->zone[j].mobile[k].mhpz, 4, fh );
          pack_fwrite( &world->zone[j].mobile[k].bhdx, 4, fh );
          pack_fwrite( &world->zone[j].mobile[k].bhdy, 4, fh );
          pack_fwrite( &world->zone[j].mobile[k].bhdz, 4, fh );
          pack_fwrite( &world->zone[j].mobile[k].gold, 4, fh );
          pack_fwrite( &world->zone[j].mobile[k].exp, 4, fh );
          pack_fwrite( &world->zone[j].mobile[k].loadpos, 4, fh );
          pack_fwrite( &world->zone[j].mobile[k].defpos, 4, fh );
          pack_fwrite( &world->zone[j].mobile[k].sex, 1, fh );
          pack_fwrite( &world->zone[j].mobile[k].num_especs, 4, fh );
          pack_fwrite( world->zone[j].mobile[k].espec, sizeof(ESPEC)*world->zone[j].mobile[k].num_especs, fh );
          }

       pack_fwrite( &world->zone[j].num_shops, 4, fh );
       pack_fwrite( &world->zone[j].last_shop_vnum, 4, fh );
       for( k = 0; k < world->zone[j].num_shops; k++ ){
          pack_fwrite( &world->zone[j].shop[k].vnum, 4, fh );

          pack_fwrite( &world->zone[j].shop[k].num_items, 4, fh );
          pack_fwrite( world->zone[j].shop[k].item, 4*world->zone[j].shop[k].num_items, fh );

          pack_fwrite( &world->zone[j].shop[k].prof_sell, 4, fh );
          pack_fwrite( &world->zone[j].shop[k].prof_buy, 4, fh );

          pack_fwrite( &world->zone[j].shop[k].num_bspecs, 4, fh );
          for( l = 0; l < world->zone[j].shop[k].num_bspecs; l++ ){
             pack_fwrite( &world->zone[j].shop[k].bspec[l].type, 4, fh );

             t = strlen( world->zone[j].shop[k].bspec[l].namelist );
             pack_fwrite( &t, 4, fh );
             pack_fwrite( world->zone[j].shop[k].bspec[l].namelist, t, fh );
             }

          t = strlen( world->zone[j].shop[k].buy_item_ne );
          pack_fwrite( &t, 4, fh );
          pack_fwrite( world->zone[j].shop[k].buy_item_ne, t, fh );

          t = strlen( world->zone[j].shop[k].sell_item_ne );
          pack_fwrite( &t, 4, fh );
          pack_fwrite( world->zone[j].shop[k].sell_item_ne, t, fh );

          t = strlen( world->zone[j].shop[k].refuse_offer );
          pack_fwrite( &t, 4, fh );
          pack_fwrite( world->zone[j].shop[k].refuse_offer, t, fh );

          t = strlen( world->zone[j].shop[k].shop_afford );
          pack_fwrite( &t, 4, fh );
          pack_fwrite( world->zone[j].shop[k].shop_afford, t, fh );

          t = strlen( world->zone[j].shop[k].play_afford );
          pack_fwrite( &t, 4, fh );
          pack_fwrite( world->zone[j].shop[k].play_afford, t, fh );

          t = strlen( world->zone[j].shop[k].buy_success );
          pack_fwrite( &t, 4, fh );
          pack_fwrite( world->zone[j].shop[k].buy_success, t, fh );

          t = strlen( world->zone[j].shop[k].sell_success );
          pack_fwrite( &t, 4, fh );
          pack_fwrite( world->zone[j].shop[k].sell_success, t, fh );

          pack_fwrite( &world->zone[j].shop[k].temper, 4, fh );
          pack_fwrite( &world->zone[j].shop[k].shop_bv, 8, fh );
          pack_fwrite( &world->zone[j].shop[k].mobile, 4, fh );
          pack_fwrite( &world->zone[j].shop[k].withwho_bv, 8, fh );

          pack_fwrite( &world->zone[j].shop[k].num_rooms, 4, fh );
          pack_fwrite( world->zone[j].shop[k].room, 4*world->zone[j].shop[k].num_rooms, fh );

          pack_fwrite( &world->zone[j].shop[k].topen[0], 4, fh );
          pack_fwrite( &world->zone[j].shop[k].tclose[0], 4, fh );
          pack_fwrite( &world->zone[j].shop[k].topen[1], 4, fh );
          pack_fwrite( &world->zone[j].shop[k].tclose[1], 4, fh );
          }

       pack_fwrite( &world->zone[j].num_tags, 4, fh );
       for( k = 0; k < world->zone[j].num_tags; k++ ){
          l = strlen( world->zone[j].tag[k].str );
          pack_fwrite( &l, 4, fh );
          pack_fwrite( world->zone[j].tag[k].str, l, fh );
   
          pack_fwrite( &world->zone[j].tag[k].x, 4, fh );
          pack_fwrite( &world->zone[j].tag[k].y, 4, fh );
          pack_fwrite( &world->zone[j].tag[k].z, 4, fh );
          }
       }

    pack_fclose( fh );

    return -1;
}

void create_blank( char *file )
{
    fclose( fopen( file, "wb" ) );
}

int export_world_wld( char *path, WORLD *world )
{
    path=0;
    world=0;
/*    char cpath[512];
    char newpath[1024];
    FILE *fh;
    int j, k, l, *zlst, nzs;  *//* couter, counter, counter, zonelist, num-zones in list */
/*    int **tlst, *nts;       *//* ThingList: one per zone, makes writing quick, nts: Number of things per zone */
/*    int tff=FALSE;          *//* Generic True/False Flag */
/*
    strncpy( cpath, path, 512 );
    zlst = malloc( 1 );
    nzs = 0;
    for( j = 0; j < world->num_rooms; j++ ){
       tff = FALSE;
       for( k = 0; k < nzs; k++ ){
          if( zlst[k] == world->room[j].zone ){
            tff = TRUE;
            break;
            }
          }
       if( !tff ){
         l = nzs++;
         zlst = realloc( zlst, sizeof(int)*nzs );
         zlst[l] = world->room[k].zone;
         }
       }
    fh = fopen( "wld\\index", "wt" );
    for( j = 0; j < nzs; j++ ){
       fprintf( fh, "%d.wld\n", zlst[j] );
       }
    fprintf( fh, "$\n" );
    fclose( fh );

    tlst = malloc( sizeof(int *) * nzs );
    nts = malloc( sizeof(int) * nzs );
    for( j = 0; j < nzs; j++ ){
       nts[j] = 0;
       tlst[j] = malloc( 1 );
       }
    for( j = 0; j < world->num_rooms; j++ ){
       k = world->room[j].zone;
       for( l = 0; l < nzs; l++ ){
          if( zlst[l] == k ){
            k = l;
            break;
            }
          }
       world->room[j].vnum = nts[k];  *//* Quick hack to assign a vnum to every room */
/*       l = nts[k]++;
       tlst[k] = realloc( tlst[k], sizeof(int)*nts[k] );
       tlst[k][l] = j;
       }

    for( j = 0; j < nzs; j++ ){
       sprintf( newpath, "wld\\%d.wld", zlst[j] );
       fh = fopen( newpath, "wt" );
       for( k = 0; k < nts[j]; k++ ){
          fprintf( fh, "#%d\n", world->zone[world->room[tlst[j][k]].zone].vnum*100+world->room[tlst[j][k]].vnum );
          fprintf( fh, "%s~\n", world->room[tlst[j][k]].title );
          fprintf( fh, "%s\n~\n", world->room[tlst[j][k]].desc );
          fprintf( fh, "%d %d %d\n", world->room[tlst[j][k]].zone, (int)(world->room[tlst[j][k]].rbv), world->room[tlst[j][k]].stype );
          for( l = 0; l < 6; l++ ){
             if( world->room[tlst[j][k]].door[l] > -1 ){
               fprintf( fh, "D%d\n", l );
               fprintf( fh, "%s\n~\n", world->door[world->room[tlst[j][k]].door[l]].desc[(int)(world->room[tlst[j][k]].si[l])] );
               fprintf( fh, "%s~\n", world->door[world->room[tlst[j][k]].door[l]].keywords[(int)(world->room[tlst[j][k]].si[l])] );
               fprintf( fh, "0 -1 %d\n", (world->zone[world->room[world->door[world->room[tlst[j][k]].door[l]].r[(world->room[tlst[j][k]].si[l]+1)%2]].zone].vnum*100)+(world->room[world->door[world->room[tlst[j][k]].door[l]].r[(world->room[tlst[j][k]].si[l]+1)%2]].vnum) );
               }
             }
          fprintf( fh, "S\n" );
          }
       fprintf( fh, "$\n" );
       fclose( fh );
       }
               */
    return -1;
}

int export_world( char *path, WORLD *world )
{
    path=0;
    world=0;
//    char cpath[512];
//    char newpath[1024];
//    FILE *fh;
//    int j, k, l, *zlst, nzs;  /* couter, counter, counter, zonelist, num-zones in list */
//    int **tlst, *nts;    /* ThingList: one per zone, makes writing quick, nts: Number of things per zone */
//    int tff=FALSE;         /* Generic True/False Flag */
/*
    getwd( cpath );

    strcpy( path, "c:\\circworld" );
    path[12] = '\0';
    mkdir( path, S_IWUSR );

    chdir( path );

    strcpy( newpath, path );
    strcat( newpath, "\\mob" );
    mkdir( newpath, S_IWUSR );

    strcpy( newpath, path );
    strcat( newpath, "\\obj" );
    mkdir( newpath, S_IWUSR );

    strcpy( newpath, path );
    strcat( newpath, "\\shp" );
    mkdir( newpath, S_IWUSR );

    strcpy( newpath, path );
    strcat( newpath, "\\wld" );
    mkdir( newpath, S_IWUSR );

    strcpy( newpath, path );
    strcat( newpath, "\\zon" );
    mkdir( newpath, S_IWUSR );

    create_blank( "mob\\index" );
    create_blank( "mob\\index.mini" );

    create_blank( "obj\\index" );
    create_blank( "obj\\index.mini" );

    create_blank( "shp\\index" );
    create_blank( "shp\\index.mini" );

    export_world_wld( "bob", world );
    create_blank( "wld\\index.mini" );


    create_blank( "zon\\index" );
    create_blank( "zon\\index.mini" );

    chdir( cpath );
              */
    return -1;
}
